SystemOrganization addCategory: #Soup!
SystemOrganization addCategory: #'Soup-Tests'!
SystemOrganization addCategory: #'Soup-Parser'!
SystemOrganization addCategory: #'Soup-TextConversion'!

TestCase subclass: #SoupDecoderTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Soup-Tests'!

!SoupDecoderTest methodsFor: 'as yet unclassified' stamp: 'za 12/30/2008 03:09'!
testSmartQuotesNotSoSmartAnymore
	| decoder |
	decoder := SoupDecoder new.
	decoder convertSmartQuotesToHtml.
	decoder string: ('{1}Foo{2} <!!-- blah -->' format: (#(145 146) collect: [:e | e asCharacter])).
	self assert: (decoder decode = '&lsquo;Foo&rsquo; <!!-- blah -->')! !

TestCase subclass: #SoupElementTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Soup-Tests'!

!SoupElementTest methodsFor: 'finding strings' stamp: 'za 12/22/2008 22:15'!
testFindNextSiblingString
	| soup b | 
	soup := Soup fromString: '<blockquote id="1"><blockquote id="1.1"></blockquote></blockquote><blockquote id="2"><blockquote id="2.1"></blockquote></blockquote><hr/>abc<br/>def<hr/><blockquote id="3"><blockquote id="3.1"></blockquote></blockquote><blockquote id="4">'.
	b := soup findTag: [:e | e id = '2'].
	self assert: (b findNextSiblingString: true) contents = 'abc'

! !

!SoupElementTest methodsFor: 'finding strings' stamp: 'za 12/22/2008 20:17'!
testFindNextSiblingStrings
	| soup b | 
	soup := Soup fromString: '<blockquote id="1"><blockquote id="1.1"></blockquote></blockquote><blockquote id="2"><blockquote id="2.1"></blockquote></blockquote>abc<br/>def<blockquote id="3"><blockquote id="3.1"></blockquote></blockquote><blockquote id="4">'.
	b := soup findTag: [:e | e id = '2'].
	self assert: (b findNextSiblingStrings: true) size = 2.

! !

!SoupElementTest methodsFor: 'finding tags' stamp: 'za 12/22/2008 22:18'!
testFindNextSiblingTag
	| soup b | 
	soup := Soup fromString: '<blockquote id="1"><blockquote id="1.1"></blockquote></blockquote><blockquote id="2"><blockquote id="2.1"></blockquote></blockquote>abc<blockquote id="3"><blockquote id="3.1"></blockquote></blockquote><blockquote id="4">'.
	b := soup findTag: [:e | e id = '2'].
	self assert: (b findNextSiblingTag: true) id = '3'

! !

!SoupElementTest methodsFor: 'finding tags' stamp: 'za 12/22/2008 20:13'!
testFindNextSiblingTags
	| soup b | 
	soup := Soup fromString: '<blockquote id="1"><blockquote id="1.1"></blockquote></blockquote><blockquote id="2"><blockquote id="2.1"></blockquote></blockquote><blockquote id="3"><blockquote id="3.1"></blockquote></blockquote><blockquote id="4">'.
	b := soup findTag: [:e | e id = '2'].
	self assert: (b findNextSiblingTags: true) size = 2.
	self assert: (b findNextSiblingTags: [:e | e id = '4']) size = 1.
! !

!SoupElementTest methodsFor: 'finding tags' stamp: 'za 12/22/2008 22:28'!
testFindNextString
	| soup b |
	soup := Soup fromString: '<b id="1"><b id="2">abc<b id="3"><b id="4">'.
	b := soup findTag: [:e | e id = '2'].
	self assert: (b findNextString: true) contents = 'abc'.

	! !

!SoupElementTest methodsFor: 'finding tags' stamp: 'za 12/22/2008 22:27'!
testFindNextStrings
	| soup b | 
	soup := Soup fromString: '<b id="1"><b id="2">abc<b id="3">def<b id="4">'.
	b := soup findTag: [:e | e name = 'b' and: [e id = '2']].
	self assert: (b findNextStrings: true) size = 2.

! !

!SoupElementTest methodsFor: 'finding tags' stamp: 'za 12/22/2008 22:20'!
testFindNextTag
	| soup b |
	soup := Soup fromString: '<b id="1"><b id="2">abc<b id="3"><b id="4">'.
	b := soup findTag: [:e | e id = '2'].
	self assert: (b findNextTag: 'b') id = '3'.

	! !

!SoupElementTest methodsFor: 'finding tags' stamp: 'za 12/22/2008 22:20'!
testFindNextTags
	| soup b | 
	soup := Soup fromString: '<b id="1"><b id="2">abc<b id="3"><b id="4">'.
	b := soup findTag: [:e | e name = 'b' and: [e id = '2']].
	self assert: (b findNextTags: 'b') size = 2.
	self assert: (b findNextTags: [:e | e name = 'b' and: [e id = '4']]) size = 1.
! !

!SoupElementTest methodsFor: 'finding strings' stamp: 'za 12/22/2008 22:14'!
testFindPreviousSiblingString
	| soup b | 
	soup := Soup fromString: '<blockquote id="1"><blockquote id="1.1"></blockquote></blockquote><blockquote id="2"><blockquote id="2.1"></blockquote></blockquote>abc<br/>def<blockquote id="3"><blockquote id="3.1"></blockquote></blockquote><blockquote id="4">'.
	b := soup findTag: [:e | e id = '3'].
	self assert: (b findPreviousSiblingString: true) contents = 'def'

! !

!SoupElementTest methodsFor: 'finding strings' stamp: 'za 12/22/2008 20:22'!
testFindPreviousSiblingStrings
	| soup b | 
	soup := Soup fromString: '<blockquote id="1"><blockquote id="1.1"></blockquote></blockquote><blockquote id="2"><blockquote id="2.1"></blockquote></blockquote>abc<br/>def<blockquote id="3"><blockquote id="3.1"></blockquote></blockquote><blockquote id="4">'.
	b := soup findTag: [:e | e id = '3'].
	self assert: (b findPreviousSiblingStrings: true) size = 2.

! !

!SoupElementTest methodsFor: 'finding tags' stamp: 'za 12/22/2008 22:12'!
testFindPreviousSiblingTag
	| soup b | 
	soup := Soup fromString: '<blockquote id="1"><blockquote id="1.1"></blockquote></blockquote><blockquote id="2"><blockquote id="2.1"></blockquote></blockquote><blockquote id="3"><blockquote id="3.1"></blockquote></blockquote><blockquote id="4">'.
	b := soup findTag: [:e | e id = '3'].
	self assert: (b findPreviousSiblingTag: true) id = '2'

! !

!SoupElementTest methodsFor: 'finding tags' stamp: 'za 12/22/2008 20:24'!
testFindPreviousSiblingTags
	| soup b | 
	soup := Soup fromString: '<blockquote id="1"><blockquote id="1.1"></blockquote></blockquote><blockquote id="2"><blockquote id="2.1"></blockquote></blockquote><blockquote id="3"><blockquote id="3.1"></blockquote></blockquote><blockquote id="4">'.
	b := soup findTag: [:e | e id = '3'].
	self assert: (b findPreviousSiblingTags: true) size = 2.
	self assert: (b findPreviousSiblingTags: [:e | e id = '1']) size = 1.
! !

!SoupElementTest methodsFor: 'finding tags' stamp: 'za 12/22/2008 22:28'!
testFindPreviousString
	| soup b |
	soup := Soup fromString: '<b id="1"><b id="2">abc<b id="3"><b id="4">'.
	b := soup findTag: [:e | e id = '3'].
	self assert: (b findPreviousString: true) contents = 'abc'.

	! !

!SoupElementTest methodsFor: 'finding tags' stamp: 'za 12/22/2008 22:32'!
testFindPreviousStrings
	| soup b | 
	soup := Soup fromString: '<b id="1"><b id="2">def<br/>abc<hr/></b><b id="3"><b id="4">'.
	b := soup findTag: 'hr'.
	self assert: (b findPreviousStrings: true) size = 2.

! !

!SoupElementTest methodsFor: 'finding tags' stamp: 'za 12/22/2008 22:20'!
testFindPreviousTag
	| soup b |
	soup := Soup fromString: '<b id="1"><b id="2">abc<b id="3"><b id="4">'.
	b := soup findTag: [:e | e id = '3'].
	self assert: (b findPreviousTag: 'b') id = '2'.

	! !

!SoupElementTest methodsFor: 'finding tags' stamp: 'za 12/22/2008 22:21'!
testFindPreviousTags
	| soup b | 
	soup := Soup fromString: '<b id="1"><b id="2">abc<b id="3"><b id="4">'.
	b := soup findTag: [:e | e name = 'b' and: [e id = '3']].
	self assert: (b findPreviousTags: 'b') size = 2.
	self assert: (b findPreviousTags: [:e | e name = 'b' and: [e id = '1']]) size = 1.
! !

!SoupElementTest methodsFor: 'accessing' stamp: 'za 12/26/2008 22:33'!
testNextSibling
	| soup li |
	soup := Soup fromString: '<ul><li>1<p>A</p>B<li>2<li>3</ul>'.
	li := (soup findTag: 'li') nextSibling.
	self assert: li name = 'li'.
	self assert: li string = '2'.
	self assert: (soup findString: '1') nextSibling name = 'p'.
	self assert: (soup findTag: 'p') nextSibling contents = 'B'.
	self assert: (soup findTag: 'p') nextSibling previousSibling nextSibling contents = 'B'.! !

SoupElementTest subclass: #SoupTagTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Soup-Tests'!

!SoupTagTest methodsFor: 'accessing' stamp: 'za 12/22/2008 17:37'!
testAddChild
	| tag childOne childTwo |
	tag := SoupTag new.
	childOne := SoupTag new.
	childTwo := SoupString new.
	tag addChild: childOne.
	self assert: (tag childAt: 1) = childOne.
	tag addChild: childTwo.
	self assert: (tag childAt: 1) = childOne.
	self assert: (tag childAt: 2) = childTwo.
	self should: [tag childAt: 3] raise: Error.
	! !

!SoupTagTest methodsFor: 'accessing' stamp: 'za 12/22/2008 17:39'!
testAttributeAt
	| tag |
	tag := SoupTag new.
	tag attributeAt: 'abc' put: 'def'.
	self assert: (tag attributeAt: 'abc') = 'def'.
	self should: (tag attributeAt: 'xyz') = nil! !

!SoupTagTest methodsFor: 'accessing' stamp: 'za 12/22/2008 17:40'!
testAttributeAtPut
	self testAttributeAt ! !

!SoupTagTest methodsFor: 'accessing' stamp: 'za 12/22/2008 17:49'!
testBeParentOf
	| parent childOne childTwo |
	parent := SoupTag new.
	childOne := SoupTag new.
	childTwo := SoupString new.
	parent beParentOf: childOne.
	parent beParentOf: childTwo.
	self assert: childOne nextSibling = childTwo.
	self assert: childTwo previousSibling = childOne.
	parent childrenDo: [
		:anElement |
		self assert: ({childOne. childTwo.} includes: anElement)
	].! !

!SoupTagTest methodsFor: 'accessing' stamp: 'za 12/22/2008 17:45'!
testBeSelfClosing
	self testIsSelfClosing! !

!SoupTagTest methodsFor: 'accessing' stamp: 'za 12/22/2008 17:45'!
testChildAt
	self testAddChild! !

!SoupTagTest methodsFor: 'enumerating' stamp: 'za 12/22/2008 19:32'!
testChildStringsDo
	| soup stringsRemaining | 
	soup := Soup fromString: '<p>xyz</p>abc<span>123</span><br/>def'.
	stringsRemaining := #(abc def) asOrderedCollection.
	soup childStringsDo: [
		:aString |
		self assert: aString isString.
		stringsRemaining remove: aString contents.
	].
	self assert: stringsRemaining isEmpty
	! !

!SoupTagTest methodsFor: 'enumerating' stamp: 'za 12/22/2008 19:26'!
testChildTagsDo
	| soup tagsRemaining | 
	soup := Soup fromString: '<p>abc</p><span>def</span><br/>'.
	tagsRemaining := #(p span br) asOrderedCollection.
	soup childTagsDo: [
		:aTag |
		self assert: aTag isTag.
		tagsRemaining remove: aTag name.
	].
	self assert: tagsRemaining isEmpty
	! !

!SoupTagTest methodsFor: 'enumerating' stamp: 'za 12/22/2008 17:44'!
testChildrenDo
	| tag childOne childTwo |
	tag := SoupTag new.
	childOne := SoupTag new.
	childTwo := SoupString new.
	tag addChild: childOne.
	tag addChild: childTwo.
	tag childrenDo: [
		:anElement |
		self assert: ({childOne. childTwo} includes: anElement) 
	].! !

!SoupTagTest methodsFor: 'error handling' stamp: 'za 12/21/2008 14:18'!
testDoesNotUnderstand
	| soup body |
	soup := Soup fromString: '<body id="a"><p id="b">a<span>b</span><br/>'.
	body := soup findTag: 'body'.
	self assert: body id = 'a'.
	self assert: body p id = 'b'.
	self assert: body br name = 'br'.
	self assert: body missing isNil.
	self should: [body test: 1] raise: MessageNotUnderstood ! !

!SoupTagTest methodsFor: 'finding strings' stamp: 'za 12/22/2008 19:08'!
testFindAllStrings
	| soup tag |
	soup := Soup fromString: '<p>abc<span>def</span></p>'.
	tag := soup p.
	self assert: (tag findString: 'def') contents = 'def'.
	self assert: (tag findString: #('def')) contents = 'def'.
	self assert: (tag findString: 'def' asRegex) contents = 'def'.
! !

!SoupTagTest methodsFor: 'finding tags' stamp: 'za 12/22/2008 19:25'!
testFindAllTags
	| soup |
	soup := Soup fromString: '<body><p>abc<br id="1"/>def<br id="2"/><span class="c">xyz</span></p></body>'.
	soup findAllTags: [:e | self assert: e isTag. true].
	self assert: (soup findAllTags: [:e | true]) size = 5.
	self assert: (soup findAllTags: [:e | false]) size = 0.	
! !

!SoupTagTest methodsFor: 'finding strings' stamp: 'za 12/22/2008 19:07'!
testFindString
	| soup tag |
	soup := Soup fromString: '<p>abc<span>def</span></p>'.
	tag := soup p.
	self assert: (tag findString: 'def') contents = 'def'.
	self assert: (tag findString: #('def')) contents = 'def'.
	self assert: (tag findString: 'def' asRegex) contents = 'def'.
! !

!SoupTagTest methodsFor: 'finding tags' stamp: 'za 12/21/2008 14:01'!
testFindTag
	| soup body |
	soup := Soup fromString: '<body><p>abc<br id="1"/>def<br id="2"/><span class="c">xyz</span></p></body>'.
	body := soup body.
	self assert: (body findTag: 'p') name = 'p'.
	self assert: (body findTag: #(p br)) name = 'p'.
	self assert: (body findTag: [:aTag | aTag name = 'br']) id = '1'.
	self assert: (body findTag: [:aTag | aTag id = '2']) name = 'br'.
	self assert: (body span) name = 'span'
! !

!SoupTagTest methodsFor: 'finding tags' stamp: 'za 12/21/2008 14:07'!
testFindTagIfPresent
	| soup body found |
	soup := Soup fromString: '<body><p>abc<br id="1"/>def<br id="2"/><span class="c">xyz</span></p></body>'.
	body := soup body.
	body findTag: 'foo' ifPresent: [self fail].
	body findTag: #(foo bar) ifPresent: [self fail].
	body findTag: [:aTag | aTag name = 'foo'] ifPresent: [self fail].
	body findTag: [:aTag | aTag id = 'bar'] ifPresent: [self fail].
	found := nil.
	body findTag: 'span' ifPresent: [:aTag | found := aTag].
	self assert: (found attributeAt: 'class') = 'c'.
	found := nil.
	body findTag: #(span) ifPresent: [:aTag | found := aTag].
	self assert: (found attributeAt: 'class') = 'c'.
	found := nil.
	body findTag: [:aTag | aTag name = 'span'] ifPresent: [:aTag | found := aTag].
	self assert: (found attributeAt: 'class') = 'c'.
	found := nil.
	body findTag: [:aTag | aTag id = '2'] ifPresent: [:aTag | found := aTag].
	self assert: found name = 'br'
	! !

!SoupTagTest methodsFor: 'testing' stamp: 'za 12/22/2008 17:42'!
testIfTag
	| tag |
	tag := SoupTag new.
	tag ifTag: [^ self].
	self fail! !

!SoupTagTest methodsFor: 'testing' stamp: 'za 12/22/2008 17:42'!
testIsSelfClosing
	| tag |
	tag := SoupTag new.
	self assert: tag isSelfClosing not.
	tag beSelfClosing.
	self assert: tag isSelfClosing.
	! !

!SoupTagTest methodsFor: 'testing' stamp: 'za 12/22/2008 17:41'!
testIsTag
	| tag |
	tag := SoupTag new.
	self assert: tag isTag.
	! !

!SoupTagTest methodsFor: 'accessing' stamp: 'za 12/22/2008 17:40'!
testName
	| tag |
	tag := SoupTag new.
	tag name: 'abc'.
	self assert: tag name = 'abc'! !

!SoupTagTest methodsFor: 'printing' stamp: 'za 12/22/2008 22:38'!
testPrintOn
	| tag |
	tag := SoupTag named: 'p'.
	self assert: tag printString = '<p></p>'.
	tag attributeAt: 'id' put: 'a'.
	self assert: tag printString = '<p id="a"></p>'.
	tag attributeAt: 'class' put: 'b'.	
	self assert: tag printString = '<p class="b" id="a"></p>'.
	tag addChild: (SoupTag named: 'span').
	self assert: tag printString = '<p class="b" id="a"><span></span></p>'.
	(tag childAt: 1) addChild: (SoupString new
		contents: 'abc';
		yourself).
	self assert: tag printString = '<p class="b" id="a"><span>abc</span></p>'.
	tag addChild: (SoupTag named: 'br')
		beSelfClosing; 
		yourself.
	self assert: tag printString = '<p class="b" id="a"><span>abc</span><br /></p>'.		
	
	! !

!SoupTagTest methodsFor: 'accessing' stamp: 'za 12/22/2008 22:56'!
testSize
	| soup |
	soup := Soup fromString: '<top>1<b>2</b>3</top><hr/>'.
	self assert: (soup size = 2)! !

!SoupTagTest methodsFor: 'accessing' stamp: 'za 12/22/2008 22:58'!
testString
	| soup |
	soup := Soup fromString: '<b>foo</b>'.
	self assert: (soup b string = 'foo').
	soup := Soup fromString: '<b>f<i>e</i>o</b>'.
	self assert: (soup b string) isNil! !

TestCase subclass: #SoupParserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Soup-Tests'!

!SoupParserTest methodsFor: 'as yet unclassified' stamp: 'za 12/24/2008 16:02'!
assertSoupFrom: aString printsAs: anotherString
	| soup |
	soup := Soup fromString: aString.
	self assert: soup printString = anotherString! !

!SoupParserTest methodsFor: 'as yet unclassified' stamp: 'za 12/25/2008 06:08'!
parseOtherDeclaration: anInteger! !

!SoupParserTest methodsFor: 'as yet unclassified' stamp: 'za 12/23/2008 06:06'!
testBadNestedTables
	| soup |
	soup := Soup fromString: '<table><tr><table><tr id=''nested''>'.
	self assert: soup table tr table tr id = 'nested'! !

!SoupParserTest methodsFor: 'as yet unclassified' stamp: 'za 12/25/2008 07:12'!
testCData
	| soup data |
	soup := Soup fromString: '<root>foo<!![CDATA[foobar]]>bar</root>'.
	data := soup findString: 'foo.*bar' asRegex. 
	self assert: data contents = 'foobar'.
	self assert: data printString = '<!![CDATA[foobar]]>'! !

!SoupParserTest methodsFor: 'as yet unclassified' stamp: 'za 12/25/2008 07:05'!
testComments
	| soup xml |
	xml := 'foo<!!--foobar-->baz'.
	soup := Soup fromString: xml.
	self assert: soup printString = xml.
	self assert: (soup findString: 'foobar') isComment
	! !

!SoupParserTest methodsFor: 'as yet unclassified' stamp: 'za 12/25/2008 06:07'!
testDeclaration
	| xml |
	xml := 'foo<!!DOCTYPE foobar>baz'.
	self assertSoupFrom: xml printsAs: xml.
	! !

!SoupParserTest methodsFor: 'as yet unclassified' stamp: 'za 12/25/2008 06:04'!
testEntitiesInAttributeValues
	| uri link |
	self assertSoupFrom: '<x t="x&#241;">' printsAs: '<x t="x"></x>'.
	self assertSoupFrom: '<x t="x&#xf1;">' printsAs: '<x t="x"></x>'.
	uri := 'http://crummy.com?sacr&eacute;&amp;bleu'.
	link := '<a href="{1}"></a>' format: uri.
	self assertSoupFrom: link printsAs: link.

! !

!SoupParserTest methodsFor: 'as yet unclassified' stamp: 'za 12/24/2008 17:44'!
testEntityConversions
	| text soup |
	text := '&lt;&lt;sacr&eacute;&#32;bleu!!&gt;&gt;'.
	soup := Soup fromString: text.
	self assert: soup printString = text.! !

!SoupParserTest methodsFor: 'as yet unclassified' stamp: 'za 12/25/2008 06:53'!
testEntityReplacement
	self assertSoupFrom: '<b>hello&nbsp;there</b>' printsAs: '<b>hello&nbsp;there</b>'! !

!SoupParserTest methodsFor: 'as yet unclassified' stamp: 'za 12/25/2008 06:52'!
testIncompleteDeclaration
	" BeautifulSoup will parse this as 'a<!!b <p>c'. It simply gives up after 
	failing to parse a doctype. I can't see the logic of this. Hence: "
	self assertSoupFrom: 'a<!!b <p>c' printsAs: 'a<!!b <p>c</p>'! !

!SoupParserTest methodsFor: 'as yet unclassified' stamp: 'za 12/24/2008 19:48'!
testJunkInDeclaration
	self 
		assertSoupFrom: '<!! Foo = -8>a'
		printsAs: '<!!Foo = -8>a'! !

!SoupParserTest methodsFor: 'as yet unclassified' stamp: 'za 12/23/2008 02:43'!
testLiteralMode
	| soup |
	soup := Soup fromString: '<script>if (i<imgs.length)</script><b>Foo</b>'.
	self assert: soup script string = 'if (i<imgs.length)'.
	self assert: soup b string = 'Foo'.
	! !

!SoupParserTest methodsFor: 'as yet unclassified' stamp: 'za 12/25/2008 01:24'!
testNakedAmpersands
	| invalidUrl validUrl |
	invalidUrl := '<a href="http://example.org?a=1&b=2;3">foo</a>'.
	validUrl := invalidUrl copyReplaceAll: '&'  with: '&amp;'.
	self assertSoupFrom: invalidUrl printsAs: validUrl.
	self assertSoupFrom: validUrl printsAs: validUrl.
	
! !

!SoupParserTest methodsFor: 'as yet unclassified' stamp: 'za 12/23/2008 06:05'!
testNestedTables
	| soup | 
	soup := Soup fromString: '<table id="1"><tr><td>Here''s another table:
        <table id="2"><tr><td>Juicy text</td></tr></table></td></tr></table>'.
	self assert: soup table table td string = 'Juicy text'.
	self assert: (soup findAllTags: 'table') size = 2.
	self assert: (soup table findAllTags: 'table') size = 1.
	self assert: (soup findTag: [:e | e name = 'table' and: [e id = '2']]) parent parent parent name = 'table'.
	soup := Soup fromString: '<table><tr><td><div><table>Foo</table></div></td></tr></table>'.
	self assert: soup table tr td div table string = 'Foo'.
	soup := Soup fromString: '<table><thead><tr>Foo</tr></thead><tbody><tr>Bar</tr></tbody>
        <tfoot><tr>Baz</tr></tfoot></table>'.
	self assert: soup table thead tr string = 'Foo'.! !

!SoupParserTest methodsFor: 'as yet unclassified' stamp: 'za 12/24/2008 19:47'!
testNonBreakingSpaces
! !

!SoupParserTest methodsFor: 'as yet unclassified' stamp: 'za 12/23/2008 04:54'!
testParaInsideBlockquote
	| soup |
	soup := Soup fromString: '<blockquote><p><b>Foo</blockquote><p>Bar'.
	self assert: soup blockquote p b string = 'Foo'.
	self assert: soup blockquote b string = 'Foo'.
	self assert: (soup findChildTag: 'p') string = 'Bar'! !

!SoupParserTest methodsFor: 'as yet unclassified' stamp: 'za 12/26/2008 22:26'!
testProcessingInstruction
	| soup data |
	soup := Soup fromString: 'abc<?pi>def'.
	data := soup findString: [:e | e isProcessingInstruction].
	self assert: data contents = 'pi'.
	self assert: data printString = '<?pi>'.
	self assert: data next contents = 'def'.! !

!SoupParserTest methodsFor: 'as yet unclassified' stamp: 'za 12/24/2008 17:39'!
testQuotedAttributeValues
	| text soup |
	self 
		assertSoupFrom: '<foo attr=''bar''></foo>' 
		printsAs: '<foo attr="bar"></foo>'.
	self 
		assertSoupFrom: '<foo attr=''bar "brawls" happen''>a</foo>' 
		printsAs: '<foo attr=''bar "brawls" happen''>a</foo>'.
		
	text := '<foo attr=''bar "brawls" happen''>a</foo>'.
	soup := Soup fromString: text.
	self assert: soup printString = text.
	soup foo attributeAt: 'attr' put: 'Brawls happen at "Bob''s Bar"'.
	self assert: soup printString = '<foo attr=''Brawls happen at "Bob&squot;s Bar"''>a</foo>'.
	
	self 
		assertSoupFrom: '<this is="really messed up & stuff">' 
		printsAs: '<this is="really messed up &amp; stuff"></this>'.
	
	" This is not what the original author had in mind, 
	but it's a legitimate interpretation of what they wrote. "
	self 
		assertSoupFrom: '<a href="foo</a>, </a><a href="bar">baz</a>' 
		printsAs: '<a href="foo&lt;/a&gt;, &lt;/a&gt;&lt;a href="></a>, <a href="bar">baz</a>'.

	" SGMLParser generates bogus parse events when attribute values
	contain embedded brackets, but at least Beautiful Soup fixes
	it up a little. "
	self 
		assertSoupFrom: '<a b="<a>">'
		printsAs: '<a b="&lt;a&gt;"></a><a>"></a>' .
	self 
		assertSoupFrom: '<a href="http://foo.com/<a> and blah and blah'
		printsAs: '<a href=''"http://foo.com/''></a><a> and blah and blah</a>'.
! !

!SoupParserTest methodsFor: 'as yet unclassified' stamp: 'za 12/23/2008 06:09'!
testSelfClosingTag
	self assert: ((Soup fromString: 'Foo<br/>Bar') findTag: 'br') printString = '<br />'.
	self assert: (Soup fromString: '<p>test1<br/>test2</p>') printString = (Soup fromString: '<p>test1<br />test2</p>') printString.
	self assert: (Soup fromString: '<p>test1<selfclosing>test2') printString = '<p>test1<selfclosing>test2</selfclosing></p>'.
	! !

!SoupParserTest methodsFor: 'as yet unclassified' stamp: 'za 12/23/2008 02:45'!
testTextArea
	| soup |
	soup := Soup fromString: '<textarea><b>This is an example of an HTML tag</b><&<&</textarea>'.
	self assert: soup textarea string = '<b>This is an example of an HTML tag</b><&<&'! !

!SoupParserTest methodsFor: 'as yet unclassified' stamp: 'za 12/24/2008 19:47'!
testWhitespaceInDeclaration
	self 
		assertSoupFrom: '<!! DOCTYPE>'
		printsAs: '<!!DOCTYPE>'! !

!Object methodsFor: '*Soup-testing' stamp: 'za 12/22/2008 18:38'!
isMatcher
	^ false! !

Object subclass: #SoupDecoder
	instanceVariableNames: 'string encoding metaEncoding xmlEncoding sniffedXmlEncoding shouldConvertSmartQuotes convertSmartQuotesTo xmlForSmartQuotes htmlForSmartQuotes xmlData'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Soup-Parser'!

!SoupDecoder methodsFor: 'as yet unclassified' stamp: 'za 12/27/2008 21:31'!
convertSmartQuote: aString
	^ convertSmartQuotesTo = #xml
		ifTrue: [self convertSmartQuoteToXml: aString]
		ifFalse: [self convertSmartQuoteToHtml: aString]
! !

!SoupDecoder methodsFor: 'as yet unclassified' stamp: 'za 12/27/2008 21:11'!
convertSmartQuoteToHtml: aString
	^ '&{1};' format: {self htmlForSmartQuote: aString}
! !

!SoupDecoder methodsFor: 'as yet unclassified' stamp: 'za 12/27/2008 21:10'!
convertSmartQuoteToXml: aString
	^ '&#x{1};' format: {self xmlForSmartQuote: aString}
! !

!SoupDecoder methodsFor: 'as yet unclassified' stamp: 'za 12/27/2008 21:04'!
convertSmartQuotes: aString
	^ ('[{1}-{2}]' format: (#(128 159) collect: [:i | i asCharacter])) asRegex
		copy: aString
		translatingMatchesUsing: [
			:smartQuote |
			self convertSmartQuote: smartQuote
		]
! !

!SoupDecoder methodsFor: 'as yet unclassified' stamp: 'za 12/27/2008 21:32'!
convertSmartQuotesToHtml
	convertSmartQuotesTo := #html
! !

!SoupDecoder methodsFor: 'as yet unclassified' stamp: 'za 12/27/2008 21:32'!
convertSmartQuotesToXml
	convertSmartQuotesTo := #xml
! !

!SoupDecoder methodsFor: 'as yet unclassified' stamp: 'za 12/30/2008 04:03'!
decode
	self possibleEncodings do: [
		:eachString |
		| decodedString |
		decodedString := self decodeFrom: eachString.
		decodedString ifNotNil: [^ decodedString]
	].
	^ string! !

!SoupDecoder methodsFor: 'as yet unclassified' stamp: 'za 12/30/2008 04:06'!
decodeFrom: encodingName
	| converter |
	converter := TextConverter newForEncoding: encodingName.
	converter ifNil: [self error: 'No text converter for ' , encodingName].
	(self shouldConvertSmartQuotes: encodingName) 
		ifTrue: [xmlData := self convertSmartQuotes: xmlData].
	^ [xmlData convertFromWithConverter: converter]
		on: Error
		do: [:e | nil]! !

!SoupDecoder methodsFor: 'as yet unclassified' stamp: 'za 12/30/2008 01:39'!
decodePythonString: aString
	^ String streamContents: [
		:aStream |
		(aString findTokens: '\x') do: [
			:eachString | 
			aStream nextPut: (Number 
				readFrom: eachString asUppercase 
				base: 16) asCharacter
		]
	]
	! !

!SoupDecoder methodsFor: 'accessing' stamp: 'za 12/30/2008 02:01'!
detectEncoding
	xmlData := string.
	[self sniffNonAsciiCompatibleEncoding.
	self sniffEncoding]
		on: Error do: [:e | ]
			! !

!SoupDecoder methodsFor: 'as yet unclassified' stamp: 'za 12/27/2008 21:37'!
encodeAsUtf8: aString
! !

!SoupDecoder methodsFor: 'as yet unclassified' stamp: 'za 12/30/2008 03:08'!
htmlForSmartQuote: aString
	^ htmlForSmartQuotes at: (aString at: 1) asInteger
! !

!SoupDecoder methodsFor: 'initialize' stamp: 'za 12/30/2008 02:21'!
initialize
	super initialize.
	self initializeXmlForSmartQuotes.
	self initializeHtmlForSmartQuotes.
	self convertSmartQuotesToXml.
	shouldConvertSmartQuotes := true! !

!SoupDecoder methodsFor: 'initialize' stamp: 'za 12/27/2008 21:34'!
initializeHtmlForSmartQuotes
	htmlForSmartQuotes := Dictionary newFrom: {
		128 -> 'euro'.
		129 -> ' '.
		130 -> 'sbquo'.
		131 -> 'fnof'.
		132 -> 'bdquo'.
		133 -> 'hellip'.
		134 -> 'dagger'.
		135 -> 'Dagger'.
		136 -> 'circ'.
		137 -> 'permil'.
		138 -> 'Scaron'.
		139 -> 'lsaquo'.
		140 -> 'OElig'.
		141 -> ' '.
		142 -> '#x17D'.
		143 -> ' '.
		144 -> ' '.
		145 -> 'lsquo'.
		146 -> 'rsquo'.
		147 -> 'ldquo'.
		148 -> 'rdquo'.
		149 -> 'bull'.
		150 -> 'ndash'.
		151 -> 'mdash'.
		152 -> 'tilde'.
		153 -> 'trade'.
		154 -> 'scaron'.
		155 -> 'rsaquo'.
		156 -> 'oelig'.
		157 -> ' '.
		158 -> '#x17E'.
		159 -> 'Yuml'.
	}.
! !

!SoupDecoder methodsFor: 'initialize' stamp: 'za 12/27/2008 21:34'!
initializeXmlForSmartQuotes
	xmlForSmartQuotes := Dictionary newFrom: {
		128 -> '20AC'.
		129 -> ' '.
		130 -> '201A'.
		131 -> '192'.
		132 -> '201E'.
		133 -> '2026'.
		134 -> '2020'.
		135 -> '2021'.
		136 -> '2C6'.
		137 -> '2030'.
		138 -> '160'.
		139 -> '2039'.
		140 -> '152'.
		141 -> ' '.
		142 -> '17D'.
		143 -> ' '.
		144 -> ' '.
		145 -> '2018'.
		146 -> '2019'.
		147 -> '201C'.
		148 -> '201D'.
		149 -> '2022'.
		150 -> '2013'.
		151 -> '2014'.
		152 -> '2DC'.
		153 -> '2122'.
		154 -> '161'.
		155 -> '203A'.
		156 -> '153'.
		157 -> ' '.
		158 -> '17E'.
		159 -> ''.
	}.
! !

!SoupDecoder methodsFor: 'as yet unclassified' stamp: 'za 12/30/2008 02:16'!
possibleEncodings
	| possibleEncodings |
	possibleEncodings := {
		encoding.
		metaEncoding.
		xmlEncoding.
		sniffedXmlEncoding.
	} asOrderedCollection reject: [:eachString | eachString isNil].
	(possibleEncodings includes: 'utf-8') 
		ifFalse: [possibleEncodings add: 'utf-8'].
	(possibleEncodings includes: 'windows-1252') 
		ifFalse: [possibleEncodings add: 'windows-1252'].
	^ possibleEncodings
	! !

!SoupDecoder methodsFor: 'as yet unclassified' stamp: 'za 12/30/2008 02:10'!
reset
	xmlEncoding := nil.
	sniffedXmlEncoding := nil.
	string := nil.
	xmlData := nil.
	! !

!SoupDecoder methodsFor: 'as yet unclassified' stamp: 'za 12/27/2008 20:57'!
shouldConvertSmartQuotes: aString
	^ shouldConvertSmartQuotes and: [
		#(
			'windows-1252'
			'iso-8859-1'
			'iso-8859-2'
		) includes: aString
	]
! !

!SoupDecoder methodsFor: 'accessing' stamp: 'za 12/30/2008 02:00'!
sniffEncoding
	| xmlEncodingMatcher |
	xmlEncodingMatcher := '^<\?.*encoding=[''"](.*?)[''"].*\?>' asRegex.
	(xmlEncodingMatcher matches: xmlData)
		ifTrue: [
  			xmlEncoding = (xmlEncodingMatcher subexpression: 1) asLowercase.
			(sniffedXmlEncoding notNil and: [
				#('iso-10646-ucs-2' 'ucs-2' 'csunicode'
				'iso-10646-ucs-4' 'ucs-4' 'csucs4'
				'utf-16' 'utf-32' 'utf_16' 'utf_32'
				'utf16' 'u16') includes: xmlEncoding
		]) ifTrue: [xmlEncoding := sniffedXmlEncoding]
	].
! !

!SoupDecoder methodsFor: 'accessing' stamp: 'za 12/30/2008 02:01'!
sniffNonAsciiCompatibleEncoding
	(self stringStartsWith: '\x4c\x6f\xa7\x94')
		ifTrue: [
	  		sniffedXmlEncoding := nil.
			^ xmlData := self convertEbcdicToAscii: string.
		].
	(self stringStartsWith: '\x00\x3c\x00\x3f')
		ifTrue: [
			sniffedXmlEncoding := 'utf-16be'.
			^ xmlData := (string convertFromEncoding: sniffedXmlEncoding) 
				convertToEncoding: 'utf-8'
		].
	((string size >= 4) 
		and: [(self stringStartsWith: '\xfe\xff') 
			and: [(self stringStartsWith: '\xfe\xff\x00\x00') not]])
		ifTrue: [
			sniffedXmlEncoding := 'utf-16be'.
			^ xmlData := ((string copyFrom: 3 to: string size) 
				convertFromEncoding: sniffedXmlEncoding) 
					convertToEncoding: 'utf-8'
		].
	(self stringStartsWith: '\x3c\x00\x3f\x00')
		ifTrue: [
			sniffedXmlEncoding := 'utf-16le'.
			^ xmlData := (string convertFromEncoding: sniffedXmlEncoding) 
				convertToEncoding: 'utf-8'
		].
	((string size >= 4) 
		and: [(self stringStartsWith: '\xff\xfe') 
			and: [(self stringStartsWith: '\xff\xfe\x00\x00') not]])
		ifTrue: [
			sniffedXmlEncoding := 'utf-16le'.
			^ xmlData := ((string copyFrom: 3 to: string size) 
				convertFromEncoding: sniffedXmlEncoding) 
					convertToEncoding: 'utf-8'
		].
	(self stringStartsWith: '\x00\x00\x00\x3c')
		ifTrue: [
			sniffedXmlEncoding := 'utf-32be'.
			^ xmlData := (string convertFromEncoding: sniffedXmlEncoding) 
				convertToEncoding: 'utf-8'
		].
	(self stringStartsWith: '\x3c\x00\x00\x00')
		ifTrue: [
			sniffedXmlEncoding := 'utf-32le'.
			^ xmlData := (string convertFromEncoding: sniffedXmlEncoding) 
				convertToEncoding: 'utf-8'
		].
	(self stringStartsWith: '\x00\x00\xfe\xff')
		ifTrue: [
			sniffedXmlEncoding := 'utf-32be'.
			^ xmlData := ((string copyFrom: 5 to: string size) 
				convertFromEncoding: sniffedXmlEncoding) 
					convertToEncoding: 'utf-8'
		].
	(self stringStartsWith: '\xff\xfe\x00\x00')
		ifTrue: [
			sniffedXmlEncoding := 'utf-32le'.
			^ xmlData := ((string copyFrom: 5 to: string size) 
				convertFromEncoding: sniffedXmlEncoding) 
					convertToEncoding: 'utf-8'
		].
	(self stringStartsWith: '\xef\xbb\xbf')
		ifTrue: [
			sniffedXmlEncoding := 'utf-8'.
			^ xmlData := ((string copyFrom: 4 to: string size) 
				convertFromEncoding: sniffedXmlEncoding) 
					convertToEncoding: 'utf-8'
		].
	sniffedXmlEncoding := 'ascii'
! !

!SoupDecoder methodsFor: 'accessing' stamp: 'za 12/30/2008 01:18'!
string: anObject
	self reset.
	string := anObject.
	self detectEncoding.! !

!SoupDecoder methodsFor: 'accessing' stamp: 'za 3/9/2009 16:08'!
stringStartsWith: aString
	^ string beginsWith: (self decodePythonString: aString)
! !

!SoupDecoder methodsFor: 'as yet unclassified' stamp: 'za 12/30/2008 03:04'!
xmlForSmartQuote: aString
	^ xmlForSmartQuotes at: (aString at: 1) asInteger
! !

Object subclass: #SoupElement
	instanceVariableNames: 'parent previous next previousSibling nextSibling'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Soup'!

!SoupElement class methodsFor: 'instance creation' stamp: 'za 12/10/2008 13:04'!
parent: anElement previous: anotherElement
	^ self new
		initializeWithParent: anElement previous: anotherElement;
		yourself! !

!SoupElement methodsFor: 'initializing' stamp: 'za 12/3/2008 18:43'!
beNextOf: anElement

	
	
! !

!SoupElement methodsFor: 'initializing' stamp: 'za 12/3/2008 18:43'!
beNextSiblingOf: anElement

	
	
! !

!SoupElement methodsFor: 'initializing' stamp: 'za 12/3/2008 18:36'!
beParentOf: anElement
! !

!SoupElement methodsFor: 'initializing' stamp: 'za 12/22/2008 19:46'!
bePreviousOf: anElement
	next := anElement! !

!SoupElement methodsFor: 'initializing' stamp: 'za 12/3/2008 18:45'!
bePreviousSiblingOf: anElement
	nextSibling := anElement
	
! !

!SoupElement methodsFor: 'finding strings' stamp: 'za 12/22/2008 20:18'!
createFindStringBlock: anObject
	(anObject isKindOf: Boolean) ifTrue: [^ [:aTag | anObject]].
	anObject isString ifTrue: [^ [:aString | aString contents = anObject]].
	anObject isMatcher ifTrue: [^ [:aString | anObject matches: aString contents]].
	anObject isCollection ifTrue: [^ [:aString | anObject includes: aString contents]].
	^ anObject! !

!SoupElement methodsFor: 'finding tags' stamp: 'za 12/22/2008 22:40'!
createFindTagBlock: anObject
	(anObject isKindOf: Boolean) ifTrue: [^ [:aTag | anObject]].
	anObject isString ifTrue: [^ [:aTag | aTag name = anObject]].
	anObject isCollection ifTrue: [^ [:aTag | anObject includes: aTag name]].
	^ anObject
! !

!SoupElement methodsFor: 'finding strings' stamp: 'za 12/25/2008 06:33'!
findAllStrings: anObject stream: aStream
! !

!SoupElement methodsFor: 'finding strings' stamp: 'za 12/23/2008 04:55'!
findChildString: anObject
	^ nil! !

!SoupElement methodsFor: 'finding tags' stamp: 'za 12/23/2008 04:55'!
findChildTag: anObject
	^ nil! !

!SoupElement methodsFor: 'finding strings' stamp: 'za 12/22/2008 22:41'!
findNextSiblingString: anObject
	| findBlock |
	nextSibling ifNil: [^ nil].
	findBlock := self createFindTagBlock: anObject.
	(nextSibling isString and: [findBlock value: nextSibling]) 
		ifTrue: [^ nextSibling].
	^ nextSibling findNextSiblingString: anObject! !

!SoupElement methodsFor: 'finding strings' stamp: 'za 12/22/2008 20:14'!
findNextSiblingStrings: anObject 
	| findBlock |
	findBlock := self createFindStringBlock: anObject.
	^ Array streamContents: [
		:aStream |
		self findNextSiblingStrings: findBlock stream: aStream
	]! !

!SoupElement methodsFor: 'finding strings' stamp: 'za 12/22/2008 20:18'!
findNextSiblingStrings: anObject stream: aStream
	| findBlock |
	nextSibling ifNil: [^ self].
	findBlock := self createFindStringBlock: anObject.
	(nextSibling isString and: [findBlock value: nextSibling]) 
		ifTrue: [aStream nextPut: nextSibling].
	nextSibling findNextSiblingStrings: anObject stream: aStream
! !

!SoupElement methodsFor: 'finding tags' stamp: 'za 12/22/2008 22:42'!
findNextSiblingTag: anObject
	| findBlock |
	nextSibling ifNil: [^ nil].
	findBlock := self createFindTagBlock: anObject.
	(nextSibling isTag and: [findBlock value: nextSibling]) 
		ifTrue: [^ nextSibling].
	^ nextSibling findNextSiblingTag: anObject! !

!SoupElement methodsFor: 'finding tags' stamp: 'za 12/22/2008 22:42'!
findNextSiblingTags: anObject 
	| findBlock |
	findBlock := self createFindTagBlock: anObject.
	^ Array streamContents: [
		:aStream |
		self findNextSiblingTags: findBlock stream: aStream
	]! !

!SoupElement methodsFor: 'finding tags' stamp: 'za 12/22/2008 22:42'!
findNextSiblingTags: anObject stream: aStream
	| findBlock |
	nextSibling ifNil: [^ self].
	findBlock := self createFindTagBlock: anObject.
	(nextSibling isTag and: [findBlock value: nextSibling]) 
		ifTrue: [aStream nextPut: nextSibling].
	nextSibling findNextSiblingTags: anObject stream: aStream
! !

!SoupElement methodsFor: 'finding strings' stamp: 'za 12/22/2008 22:42'!
findNextString: anObject
	| findBlock |
	next ifNil: [^ nil].
	findBlock := self createFindTagBlock: anObject.
	(next isString and: [findBlock value: next]) ifTrue: [^ next].
	^ next findNextString: anObject! !

!SoupElement methodsFor: 'finding strings' stamp: 'za 12/22/2008 19:52'!
findNextStrings: anObject 
	| findBlock |
	findBlock := self createFindStringBlock: anObject.
	^ Array streamContents: [
		:aStream |
		self findNextStrings: findBlock stream: aStream
	]! !

!SoupElement methodsFor: 'finding strings' stamp: 'za 12/22/2008 20:19'!
findNextStrings: anObject stream: aStream
	| findBlock |
	next ifNil: [^ self].
	findBlock := self createFindStringBlock: anObject.
	(next isString and: [findBlock value: next]) ifTrue: [aStream nextPut: next].
	next findNextStrings: anObject stream: aStream
! !

!SoupElement methodsFor: 'finding tags' stamp: 'za 12/22/2008 22:42'!
findNextTag: anObject
	| findBlock |
	next ifNil: [^ nil].
	findBlock := self createFindTagBlock: anObject.
	(next isTag and: [findBlock value: next]) ifTrue: [^ next].
	^ next findNextTag: anObject! !

!SoupElement methodsFor: 'finding tags' stamp: 'za 12/22/2008 22:44'!
findNextTags: anObject 
	| findBlock |
	findBlock := self createFindTagBlock: anObject.
	^ Array streamContents: [
		:aStream |
		self findNextTags: findBlock stream: aStream
	]! !

!SoupElement methodsFor: 'finding tags' stamp: 'za 12/22/2008 22:45'!
findNextTags: anObject stream: aStream
	| findBlock |
	next ifNil: [^ self].
	findBlock := self createFindTagBlock: anObject.
	(next isTag and: [findBlock value: next]) ifTrue: [aStream nextPut: next].
	next findNextTags: anObject stream: aStream
! !

!SoupElement methodsFor: 'finding strings' stamp: 'za 12/22/2008 22:43'!
findPreviousSiblingString: anObject
	| findBlock |
	previousSibling ifNil: [^ nil].
	findBlock := self createFindTagBlock: anObject.
	(previousSibling isString and: [findBlock value: previousSibling]) 
		ifTrue: [^ previousSibling].
	^ previousSibling findPreviousSiblingString: anObject! !

!SoupElement methodsFor: 'finding strings' stamp: 'za 12/22/2008 20:20'!
findPreviousSiblingStrings: anObject 
	| findBlock |
	findBlock := self createFindStringBlock: anObject.
	^ Array streamContents: [
		:aStream |
		self findPreviousSiblingStrings: findBlock stream: aStream
	]! !

!SoupElement methodsFor: 'finding strings' stamp: 'za 12/22/2008 20:20'!
findPreviousSiblingStrings: anObject stream: aStream
	| findBlock |
	previousSibling ifNil: [^ self].
	findBlock := self createFindStringBlock: anObject.
	(previousSibling isString and: [findBlock value: previousSibling]) 
		ifTrue: [aStream nextPut: previousSibling].
	previousSibling findPreviousSiblingStrings: anObject stream: aStream
! !

!SoupElement methodsFor: 'finding tags' stamp: 'za 12/22/2008 22:43'!
findPreviousSiblingTag: anObject
	| findBlock |
	previousSibling ifNil: [^ nil].
	findBlock := self createFindTagBlock: anObject.
	(findBlock value: previousSibling) ifTrue: [^ previousSibling].
	^ previousSibling findPreviousSiblingTag: anObject! !

!SoupElement methodsFor: 'finding tags' stamp: 'za 12/22/2008 22:43'!
findPreviousSiblingTags: anObject 
	| findBlock |
	findBlock := self createFindTagBlock: anObject.
	^ Array streamContents: [
		:aStream |
		self findPreviousSiblingTags: findBlock stream: aStream
	]! !

!SoupElement methodsFor: 'finding tags' stamp: 'za 12/22/2008 22:43'!
findPreviousSiblingTags: anObject stream: aStream
	| findBlock |
	previousSibling ifNil: [^ self].
	findBlock := self createFindTagBlock: anObject.
	(previousSibling isTag and: [findBlock value: previousSibling]) 
		ifTrue: [aStream nextPut: previousSibling].
	previousSibling findPreviousSiblingTags: anObject stream: aStream
! !

!SoupElement methodsFor: 'finding strings' stamp: 'za 12/22/2008 22:43'!
findPreviousString: anObject
	| findBlock |
	previous ifNil: [^ nil].
	findBlock := self createFindTagBlock: anObject.
	(previous isString and: [findBlock value: previous]) ifTrue: [^ previous].
	^ previous findNextString: anObject! !

!SoupElement methodsFor: 'finding strings' stamp: 'za 12/22/2008 20:21'!
findPreviousStrings: anObject 
	| findBlock |
	findBlock := self createFindStringBlock: anObject.
	^ Array streamContents: [
		:aStream |
		self findPreviousStrings: findBlock stream: aStream
	]! !

!SoupElement methodsFor: 'finding strings' stamp: 'za 12/22/2008 22:35'!
findPreviousStrings: anObject stream: aStream
	| findBlock |
	previous ifNil: [^ self].
	findBlock := self createFindStringBlock: anObject.
	(previous isString and: [findBlock value: previous]) ifTrue: [aStream nextPut: previous].
	previous findPreviousStrings: anObject stream: aStream
! !

!SoupElement methodsFor: 'finding tags' stamp: 'za 12/22/2008 22:43'!
findPreviousTag: anObject
	| findBlock |
	previous ifNil: [^ nil].
	findBlock := self createFindTagBlock: anObject.
	(findBlock value: previous) ifTrue: [^ previous].
	^ previous findPreviousTag: anObject! !

!SoupElement methodsFor: 'finding tags' stamp: 'za 12/22/2008 22:42'!
findPreviousTags: anObject 
	| findBlock |
	findBlock := self createFindTagBlock: anObject.
	^ Array streamContents: [
		:aStream |
		self findPreviousTags: findBlock stream: aStream
	]! !

!SoupElement methodsFor: 'finding tags' stamp: 'za 12/22/2008 22:41'!
findPreviousTags: anObject stream: aStream
	| findBlock |
	previous ifNil: [^ self].
	findBlock := self createFindTagBlock: anObject.
	(previous isTag and: [findBlock value: previous]) ifTrue: [aStream nextPut: previous].
	previous findPreviousTags: anObject stream: aStream
! !

!SoupElement methodsFor: 'testing' stamp: 'za 12/22/2008 19:29'!
ifString: aBlock! !

!SoupElement methodsFor: 'testing' stamp: 'za 12/22/2008 19:18'!
ifTag: aBlock
	! !

!SoupElement methodsFor: 'initializing' stamp: 'za 12/3/2008 18:37'!
initializeWithParent: anElement previous: anotherElement
	self parent: anElement.
	self previous: anotherElement.! !

!SoupElement methodsFor: 'testing' stamp: 'za 12/25/2008 07:01'!
isCData
	^ false! !

!SoupElement methodsFor: 'testing' stamp: 'za 12/25/2008 07:14'!
isComment 
	^ false! !

!SoupElement methodsFor: 'testing' stamp: 'za 12/25/2008 06:32'!
isDeclaration
	^ false! !

!SoupElement methodsFor: 'testing' stamp: 'za 12/25/2008 07:18'!
isProcessingInstruction
	^ false! !

!SoupElement methodsFor: 'testing' stamp: 'za 12/22/2008 19:18'!
isSoup
	^ false! !

!SoupElement methodsFor: 'testing' stamp: 'za 12/22/2008 19:18'!
isString
	^ false! !

!SoupElement methodsFor: 'testing' stamp: 'za 12/22/2008 19:18'!
isTag
	^ false! !

!SoupElement methodsFor: 'accessing' stamp: 'za 12/20/2008 10:33'!
name
	^ nil! !

!SoupElement methodsFor: 'accessing' stamp: 'za 12/22/2008 17:48'!
next
	^ next! !

!SoupElement methodsFor: 'accessing' stamp: 'za 12/3/2008 18:45'!
next: anElement
	anElement beNextOf: self.
	next := anElement

! !

!SoupElement methodsFor: 'accessing' stamp: 'za 12/22/2008 17:47'!
nextSibling
	^ nextSibling! !

!SoupElement methodsFor: 'accessing' stamp: 'za 12/3/2008 18:42'!
nextSibling: anElement
	anElement beNextSiblingOf: self.
	nextSibling := anElement.
	
	
! !

!SoupElement methodsFor: 'accessing' stamp: 'za 12/22/2008 18:43'!
parent
	^ parent! !

!SoupElement methodsFor: 'accessing' stamp: 'za 12/3/2008 18:45'!
parent: anElement
	anElement beParentOf: self.
	parent := anElement

! !

!SoupElement methodsFor: 'accessing' stamp: 'za 12/22/2008 17:48'!
previous
	^ previous! !

!SoupElement methodsFor: 'accessing' stamp: 'test 12/22/2008 20:47'!
previous: anElement
	anElement ifNotNil: [anElement bePreviousOf: self].
	previous := anElement

! !

!SoupElement methodsFor: 'accessing' stamp: 'za 12/22/2008 17:47'!
previousSibling
	^ previousSibling! !

!SoupElement methodsFor: 'accessing' stamp: 'za 12/3/2008 18:41'!
previousSibling: anElement
	anElement bePreviousSiblingOf: self.
	previousSibling := anElement.
! !

!SoupElement methodsFor: 'printing' stamp: 'za 12/22/2008 19:18'!
printOn: aStream 
	self subclassResponsibility
! !

SoupElement subclass: #SoupString
	instanceVariableNames: 'contents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Soup'!

SoupString subclass: #SoupCData
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Soup'!

!SoupCData methodsFor: 'testing' stamp: 'za 12/25/2008 07:01'!
isCData
	^ true! !

!SoupCData methodsFor: 'printing' stamp: 'za 12/25/2008 07:13'!
printOn: aStream
	aStream 
		nextPutAll: '<!![CDATA[';
		nextPutAll: contents;
		nextPutAll: ']]>'! !

SoupString subclass: #SoupComment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Soup'!

!SoupComment methodsFor: 'testing' stamp: 'za 12/25/2008 07:14'!
isComment
	^ true! !

!SoupComment methodsFor: 'printing' stamp: 'za 12/25/2008 07:13'!
printOn: aStream
	aStream 
		nextPutAll: '<!!--';
		nextPutAll: contents;
		nextPutAll: '-->'! !

SoupString subclass: #SoupDeclaration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Soup'!

!SoupDeclaration methodsFor: 'testing' stamp: 'za 12/25/2008 06:32'!
isDeclaration
	^ true! !

!SoupDeclaration methodsFor: 'printing' stamp: 'za 12/25/2008 06:42'!
printOn: aStream
	aStream 
		nextPutAll: '<!!';
		nextPutAll: contents;
		nextPutAll: '>'! !

SoupString subclass: #SoupProcessingInstruction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Soup'!

!SoupProcessingInstruction methodsFor: 'testing' stamp: 'za 12/25/2008 07:19'!
isProcessingInstruction
	^ true! !

!SoupProcessingInstruction methodsFor: 'printing' stamp: 'za 12/25/2008 07:19'!
printOn: aStream
	aStream 
		nextPutAll: '<?';
		nextPutAll: contents;
		nextPutAll: '>'! !

!SoupString class methodsFor: 'instance creation' stamp: 'za 12/22/2008 22:44'!
parent: anElement previous: anotherElement contents: aString
	^ (super parent: anElement previous: anotherElement)
		contents: aString;
		yourself! !

!SoupString methodsFor: 'accessing' stamp: 'za 12/22/2008 22:47'!
contents
	^ contents! !

!SoupString methodsFor: 'accessing' stamp: 'za 12/22/2008 22:39'!
contents: anObject
	contents := anObject! !

!SoupString methodsFor: 'finding strings' stamp: 'za 12/22/2008 22:37'!
findAllStrings: anObject
	^ #()! !

!SoupString methodsFor: 'finding tags' stamp: 'za 12/22/2008 22:37'!
findAllTags: anObject
	^ #()! !

!SoupString methodsFor: 'finding strings' stamp: 'za 12/22/2008 22:37'!
findString: anObject
	^ nil! !

!SoupString methodsFor: 'finding tags' stamp: 'za 12/22/2008 22:37'!
findTag: anObject
	^ nil! !

!SoupString methodsFor: 'testing' stamp: 'za 12/22/2008 19:29'!
ifString: aBlock
	^ aBlock value.! !

!SoupString methodsFor: 'testing' stamp: 'za 12/9/2008 14:52'!
isString
	^ true! !

!SoupString methodsFor: 'printing' stamp: 'za 12/22/2008 22:39'!
printOn: aStream
	aStream nextPutAll: contents.
! !

!SoupString methodsFor: 'as yet unclassified' stamp: 'za 2/5/2009 03:01'!
readStream
	^ contents readStream! !

!SoupString methodsFor: 'accessing' stamp: 'za 12/25/2008 08:13'!
text
	^ contents! !

SoupElement subclass: #SoupTag
	instanceVariableNames: 'name attributes children isSelfClosing'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Soup'!

SoupTag subclass: #Soup
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Soup'!

!Soup class methodsFor: 'licensing' stamp: 'za 12/30/2008 04:46'!
License
" Licensed like BeautifulSoup (see Soup OriginalLicense) "
	self error: 'comment only'! !

!Soup class methodsFor: 'licensing' stamp: 'za 12/30/2008 04:46'!
OriginalLicense
"Copyright (c) 2004-2007, Leonard Richardson

All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are
met:

  * Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.

  * Redistributions in binary form must reproduce the above
    copyright notice, this list of conditions and the following
    disclaimer in the documentation and/or other materials provided
    with the distribution.

  * Neither the name of the the Beautiful Soup Consortium and All
    Night Kosher Bakery nor the names of its contributors may be
    used to endorse or promote products derived from this software
    without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
""AS IS"" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE, DAMMIT.

"
	self error: 'comment only'! !

!Soup class methodsFor: 'defaults' stamp: 'za 12/26/2008 22:29'!
defaultName
	^ '[document]'! !

!Soup class methodsFor: 'defaults' stamp: 'za 12/20/2008 10:46'!
defaultParserParameters
	^ SoupParserParameters forHtml! !

!Soup class methodsFor: 'instance creation' stamp: 'za 12/20/2008 10:45'!
fromString: aString
	^ (SoupParser parameters: self defaultParserParameters) 
		parseString: aString! !

!Soup class methodsFor: 'instance creation' stamp: 'za 2/11/2009 02:39'!
fromUrl: aString
	Transcript show: aString; cr; flush.
	^ self fromString: (HTTPClient httpGet: aString) contents
! !

!Soup class methodsFor: 'instance creation' stamp: 'za 12/26/2008 22:29'!
new
	^ super new
		name: self defaultName;
		yourself! !

!Soup methodsFor: 'accessing' stamp: 'za 12/20/2008 11:00'!
addChild: aChild
	^ children add: aChild! !

!Soup methodsFor: 'error handling' stamp: 'za 12/21/2008 13:58'!
doesNotUnderstand: aMessage
	" Treat only unary messages as short hand child access. "
	(aMessage arguments size > 0)
		ifTrue: [^ super doesNotUnderstand: aMessage].
	self 
		findTag: aMessage selector
		ifPresent: [:aTag | ^ aTag].
	^ nil! !

!Soup methodsFor: 'initialization' stamp: 'za 12/23/2008 04:42'!
initialize
	super initialize.
	self name = '[document]'! !

!Soup methodsFor: 'testing' stamp: 'za 12/20/2008 10:59'!
isSoup
	^ true! !

!Soup methodsFor: 'printing' stamp: 'za 12/22/2008 21:59'!
printOn: aStream
	self childrenDo: [
		:eachElement |
		eachElement printOn: aStream.
	].
! !

!SoupTag class methodsFor: 'instance creation' stamp: 'za 12/22/2008 17:56'!
named: aString
	^ self new 
		name: aString;
		yourself! !

!SoupTag class methodsFor: 'instance creation' stamp: 'za 12/10/2008 16:24'!
named: aString parent: anElement previous: anotherElement
	^ (self parent: anElement previous: anotherElement)
		name: aString;
		yourself! !

!SoupTag methodsFor: 'accessing' stamp: 'za 12/9/2008 14:14'!
addChild: aChild
	^ children add: aChild! !

!SoupTag methodsFor: 'accessing' stamp: 'za 12/10/2008 16:55'!
attributeAt: aString 
	^ attributes at: aString ifAbsent: [nil]! !

!SoupTag methodsFor: 'accessing' stamp: 'za 12/7/2008 05:52'!
attributeAt: aString put: anotherString
	^ attributes at: aString put: anotherString! !

!SoupTag methodsFor: 'initializing' stamp: 'za 12/11/2008 00:34'!
beParentOf: anElement
	children ifNotEmpty: [anElement previousSibling: children last].
	children add: anElement.
	! !

!SoupTag methodsFor: 'accessing' stamp: 'za 12/10/2008 16:24'!
beSelfClosing
	isSelfClosing := true! !

!SoupTag methodsFor: 'accessing' stamp: 'za 12/9/2008 14:15'!
childAt: anInteger
	^ children at: anInteger! !

!SoupTag methodsFor: 'enumerating' stamp: 'za 12/22/2008 19:28'!
childStringsDo: aBlock
	self childrenDo: [
		:anElement |
		anElement ifString: [aBlock value: anElement]
	]! !

!SoupTag methodsFor: 'enumerating' stamp: 'za 12/21/2008 13:47'!
childTagsDo: aBlock
	self childrenDo: [
		:anElement |
		anElement ifTag: [aBlock value: anElement]
	]! !

!SoupTag methodsFor: 'enumerating' stamp: 'za 12/21/2008 13:48'!
childrenDo: aBlock
	children do: aBlock! !

!SoupTag methodsFor: 'error handling' stamp: 'za 12/21/2008 13:57'!
doesNotUnderstand: aMessage
	" Treat only unary messages as short hand attribute or child access. "
	(aMessage arguments size > 0)
		ifTrue: [^ super doesNotUnderstand: aMessage].
	attributes 
		at: aMessage selector
		ifPresent: [:aString | ^ aString].
	self 
		findTag: aMessage selector
		ifPresent: [:aTag | ^ aTag].
	^ nil! !

!SoupTag methodsFor: 'finding strings' stamp: 'za 12/22/2008 19:02'!
findAllStrings: anObject
	| block |
	block := self createFindStringBlock: anObject.
	^ Array streamContents: [
		:aStream |
		self findAllStrings: block stream: aStream
	]! !

!SoupTag methodsFor: 'finding strings' stamp: 'za 12/22/2008 19:10'!
findAllStrings: anObject stream: aStream
	| findBlock |
	findBlock := self createFindStringBlock: anObject.
	self childStringsDo: [
		:aString |
		 (findBlock value: aString) ifTrue: [aStream nextPut: aString].
		aString findAllStrings: findBlock stream: aStream.
	].! !

!SoupTag methodsFor: 'finding tags' stamp: 'za 12/22/2008 22:41'!
findAllTags: anObject 
	| findBlock |
	findBlock := self createFindTagBlock: anObject.
	^ Array streamContents: [
		:aStream |
		self findAllTags: findBlock stream: aStream
	]! !

!SoupTag methodsFor: 'finding tags' stamp: 'za 12/22/2008 22:41'!
findAllTags: anObject stream: aStream
	| findBlock |
	findBlock := self createFindTagBlock: anObject.
	self childTagsDo: [
		:aTag |
		 (findBlock value: aTag) ifTrue: [aStream nextPut: aTag].
		aTag findAllTags: findBlock stream: aStream.
	].! !

!SoupTag methodsFor: 'finding strings' stamp: 'za 12/23/2008 04:56'!
findChildString: anObject
	| findBlock |
	findBlock := self createFindStringBlock: anObject.
	self childStringsDo: [
		:aString |
		(findBlock value: aString)  ifTrue: [^ aString].
	].
	^ nil! !

!SoupTag methodsFor: 'finding tags' stamp: 'za 12/23/2008 04:55'!
findChildTag: anObject
	| findBlock |
	findBlock := self createFindTagBlock: anObject.
	self childTagsDo: [
		:aTag |
		(findBlock value: aTag)  ifTrue: [^ aTag].
	].
	^ nil! !

!SoupTag methodsFor: 'finding strings' stamp: 'za 12/22/2008 18:34'!
findString: anObject
	| block |
	block := self createFindStringBlock: anObject.
	self childrenDo: [
		:eachElement |
		eachElement isString
			ifTrue: [(block value: eachElement) ifTrue: [^ eachElement]]
			ifFalse: [
				| found |
				found := eachElement findString: block.
				found ifNotNil: [^ found]
			]
	].
	^ nil
		! !

!SoupTag methodsFor: 'finding strings' stamp: 'za 12/22/2008 19:33'!
findString: anObject ifPresent: aBlock
	| found |
	found := self findString: anObject.
	^ found ifNotNil: [aBlock value: found]! !

!SoupTag methodsFor: 'finding tags' stamp: 'za 12/22/2008 22:41'!
findTag: anObject
	| findBlock |
	findBlock := self createFindTagBlock: anObject.
	self childTagsDo: [
		:aTag |
		| found |
		(findBlock value: aTag) 
			ifTrue: [^ aTag].
		found := (aTag findTag: findBlock).
		found ifNotNil: [^ found]
	].
	^ nil! !

!SoupTag methodsFor: 'finding tags' stamp: 'za 12/21/2008 13:56'!
findTag: anObject ifPresent: aBlock
	| found |
	found := self findTag: anObject.
	^ found ifNotNil: [aBlock value: found]
! !

!SoupTag methodsFor: 'finding tags' stamp: 'za 2/5/2009 02:51'!
findTagByClass: aString ifAbsent: aBlock
	self findTag: [:aTag | (aTag attributeAt: 'class') = aString]
		ifPresent: [:aTag | ^ aTag].
	^ aBlock value
! !

!SoupTag methodsFor: 'finding tags' stamp: 'za 2/4/2009 10:23'!
findTagByClass: aString ifPresent: aBlock
	^ self 
		findTag: [:aTag | (aTag attributeAt: 'class') = aString]
		ifPresent: aBlock
! !

!SoupTag methodsFor: 'testing' stamp: 'za 12/21/2008 13:47'!
ifTag: aBlock
	aBlock value! !

!SoupTag methodsFor: 'initializing' stamp: 'za 12/10/2008 16:21'!
initialize
	super initialize.
	attributes := Dictionary new.
	children := OrderedCollection new.
	isSelfClosing := false.! !

!SoupTag methodsFor: 'accessing' stamp: 'za 12/10/2008 16:24'!
isSelfClosing
	^ isSelfClosing! !

!SoupTag methodsFor: 'testing' stamp: 'za 12/9/2008 14:52'!
isTag
	^ true! !

!SoupTag methodsFor: 'accessing' stamp: 'za 12/7/2008 04:24'!
name
	^ name! !

!SoupTag methodsFor: 'accessing' stamp: 'za 12/7/2008 04:24'!
name: anObject
	name := anObject! !

!SoupTag methodsFor: 'printing' stamp: 'za 12/24/2008 15:53'!
printAttributeValue: aString on: aStream
	| quote string entityMatcher bareSymbolMatcher replacementEntities |
	(aString includes: $")
		ifTrue: [
			string := (aString includes: $')
				ifTrue: [aString copyReplaceAll: '''' with: '&squot;']
				ifFalse: [aString].
			quote := $'.
		]
		ifFalse: [
			string := aString.
			quote := $"
		].
	bareSymbolMatcher := '[<>&]' asRegex.
	entityMatcher := '(#\d+;)|(#x[0-9a-fA-F]+;)|(\w+;)' asRegex.
	replacementEntities := Dictionary newFrom: {'<' -> '&lt;'. '>' -> '&gt;'. '&' -> '&amp;'}.
	string := bareSymbolMatcher copy: string translatingMatchesUsing: [
		:matchedString |
		(entityMatcher matchesStreamPrefix: (string readStream
			position: (bareSymbolMatcher subEnd: 1);
			yourself))
				ifTrue: [matchedString]
				ifFalse: [replacementEntities at: matchedString]
		].
	aStream 
		nextPut: quote;
		nextPutAll: string;
		nextPut: quote.
! !

!SoupTag methodsFor: 'printing' stamp: 'za 12/24/2008 15:51'!
printOn: aStream
	aStream 
		nextPut: $<;
		nextPutAll: name.
	attributes keysAndValuesDo: [
		:key :value |
		aStream 
			nextPut: $ ;
			nextPutAll: key;
			nextPutAll: '='.
		self printAttributeValue: value on: aStream.
	].
	isSelfClosing 
		ifTrue: [aStream nextPutAll: ' />']
		ifFalse: [
			aStream nextPut: $>.
			children do: [
				:eachElement |
				eachElement printOn: aStream.
			].
			aStream 
				nextPutAll: '</';
				nextPutAll: name;
				nextPut: $>
		]! !

!SoupTag methodsFor: 'accessing' stamp: 'za 12/22/2008 22:54'!
size
	^ children size! !

!SoupTag methodsFor: 'accessing' stamp: 'za 12/22/2008 22:51'!
string
	^ (children size = 1 and: [(children at: 1) isString])
		ifTrue: [(children at: 1) contents]
		ifFalse: [nil]! !

!SoupTag methodsFor: 'accessing' stamp: 'za 12/25/2008 08:13'!
text
	^ String streamContents: [
		:aStream |
		children do: [
			:eachElement | 
			aStream nextPutAll: eachElement text
		]
	]! !

Object subclass: #SoupParser
	instanceVariableNames: 'string currentData tagStack quoteStack interesting startTagOpen charRef entityRef endBracket tagFind attrFind entityOrCharRef previous literal parameters incomplete refFind'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Soup-Parser'!

!SoupParser class methodsFor: 'instance creation' stamp: 'za 12/20/2008 11:07'!
parameters: aParameters
	^ self new 
		parameters: aParameters;
		yourself
	! !

!SoupParser methodsFor: 'converting' stamp: 'za 3/9/2009 16:08'!
convertCharRef: aString
	| codePoint |
	[
		codePoint := (aString beginsWith: 'x')
			ifTrue: [Number readFrom: (aString allButFirst: 1) asUppercase base: 16]
			ifFalse: [Integer readFrom: aString readStream].
	] on: Error do: [
		^ nil
	].
	^ self convertCodePoint: codePoint
! !

!SoupParser methodsFor: 'converting' stamp: 'za 12/25/2008 01:54'!
convertCodePoint: codePoint
	^ codePoint asCharacter asString
! !

!SoupParser methodsFor: 'converting' stamp: 'za 12/26/2008 23:11'!
convertEntityRef: aString
	^ parameters entityDefinitions at: aString ifAbsent: [nil]
! !

!SoupParser methodsFor: 'converting' stamp: 'PaulDeBruicker 2/19/2010 09:39'!
convertRef: aMatcher
	(aMatcher subexpression: 3) 
		ifNotNil: [
			^ (self convertCharRef: (aMatcher subexpression: 3))
				ifNil: [aMatcher subexpression: 1]
		].
	(aMatcher subexpression: 4)
		ifNotNil: [
			^ (self convertEntityRef: (aMatcher subexpression: 4))
				ifNil: [aMatcher subexpression: 1]
		].
	^ aMatcher subexpression: 1
! !

!SoupParser methodsFor: 'massaging' stamp: 'za 2/11/2009 04:26'!
copy: aString replace: regexStringOrMatcher using: aBlock
	| matcher |
	matcher := regexStringOrMatcher isMatcher
		ifTrue: [regexStringOrMatcher]
		ifFalse: [regexStringOrMatcher asRegex].
	^ matcher copy: aString translatingMatchesUsing: [
		:matchString |
		" Pass the matcher as it has all the information we need 
		and we can always reconstruct the matched string. "
		aBlock value: matcher.
		]! !

!SoupParser methodsFor: 'initializing' stamp: 'za 12/20/2008 10:56'!
createRootTag
	^ Soup new
! !

!SoupParser methodsFor: 'parsing' stamp: 'za 12/30/2008 04:02'!
decode
	| decoder |
	decoder := SoupDecoder new.
	decoder convertSmartQuotesToHtml.
	decoder string: string.
	string := decoder decode.! !

!SoupParser methodsFor: 'handling' stamp: 'za 12/10/2008 13:05'!
endData
	self endData: SoupString! !

!SoupParser methodsFor: 'handling' stamp: 'za 2/15/2009 18:48'!
endData: aClass
	| data dataWithoutSeparators element |
	(currentData size = 0) ifTrue: [^ self].
	data := currentData contents.
	dataWithoutSeparators := data reject: [:aChar | aChar isSeparator].
	dataWithoutSeparators 
		ifEmpty: [
			data := (data includes: Character cr)
				ifTrue: [String cr]
				ifFalse: [' ']
		].
	currentData := ReadWriteStream on: String new.
	element := aClass parent: tagStack last previous: previous contents: data.
	previous := element.
	 ! !

!SoupParser methodsFor: 'parsing' stamp: 'za 12/10/2008 23:06'!
equals: aString from: anInteger
	(anInteger > string size) ifTrue: [^ false].
	(anInteger + aString size > string size) ifTrue: [^ false].
	aString withIndexDo: [
		:eachChar :eachInteger |
		(string at: (eachInteger + anInteger)) = eachChar
			ifFalse: [^ false]
	].
	^ true! !

!SoupParser methodsFor: 'parsing' stamp: 'PaulDeBruicker 2/19/2010 09:26'!
findInterestingFrom: anInteger
	^ (interesting searchStream: (self readStreamFrom: anInteger))
		ifTrue: [(interesting subBeginning: 1) first]
		ifFalse: [string size]
! !

!SoupParser methodsFor: 'handling' stamp: 'za 12/25/2008 07:02'!
handleCData: aString
	self endData.
	self handleData: aString.
	self endData: SoupCData.

	
! !

!SoupParser methodsFor: 'handling' stamp: 'za 12/24/2008 18:22'!
handleCharRef: aString
	^ self handleData: (String streamContents: [
		:aStream |
		aStream 
			nextPut: $&;
			nextPut: $#;
			nextPutAll: aString;
			nextPut: $;])! !

!SoupParser methodsFor: 'handling' stamp: 'za 12/25/2008 07:10'!
handleComment: aString
	self endData.
	self handleData: aString.
	self endData: SoupComment

	
! !

!SoupParser methodsFor: 'handling' stamp: 'za 12/10/2008 23:52'!
handleData: aString
	currentData nextPutAll: aString

! !

!SoupParser methodsFor: 'handling' stamp: 'za 12/9/2008 16:14'!
handleDataFrom: anInteger to: anotherInteger
	anInteger to: anotherInteger do: [
		:i |
		currentData nextPut: (string at: i)
		]
! !

!SoupParser methodsFor: 'handling' stamp: 'za 12/25/2008 06:41'!
handleDeclaration: aString
	self endData.
	self handleData: aString.
	self endData: SoupDeclaration.

	
! !

!SoupParser methodsFor: 'handling' stamp: 'za 12/23/2008 06:01'!
handleEndTag: aString
	(quoteStack isEmpty not and: [quoteStack last ~= aString])
		ifTrue: [^ self handleData: (String streamContents: [
			:stream | 
				stream nextPutAll: '</'; nextPutAll: aString; nextPutAll: '>'
			])].
	self endData.
	self popToTag: aString.
	(quoteStack isEmpty not and: [quoteStack last = aString])
		ifTrue: [
			quoteStack removeLast.
			literal := quoteStack isEmpty not
		]
! !

!SoupParser methodsFor: 'handling' stamp: 'za 12/23/2008 06:01'!
handleEndTagFrom: anInteger to: anotherInteger tag: aString
	(quoteStack isEmpty not and: [quoteStack last ~= aString])
		ifTrue: [^ self handleDataFrom: anInteger to: anotherInteger].
	self endData.
	self popToTag: aString.
	(quoteStack isEmpty not and: [quoteStack last = aString])
		ifTrue: [
			quoteStack removeLast.
			literal := quoteStack isEmpty not
		]
! !

!SoupParser methodsFor: 'handling' stamp: 'za 12/24/2008 18:21'!
handleEntityRef: aString
	^ self handleData: (String streamContents: [
		:aStream |
		aStream 
			nextPut: $&;
			nextPutAll: aString;
			nextPut: $;])! !

!SoupParser methodsFor: 'handling' stamp: 'za 12/25/2008 07:18'!
handleProcessingInstruction: aString
	self endData.
	self handleData: aString.
	self endData: SoupProcessingInstruction 

	
! !

!SoupParser methodsFor: 'handling' stamp: 'za 12/26/2008 22:56'!
handleStartTagFrom: anInteger to: anotherInteger tag: aString attrs: aDictionary
	| tag |
	quoteStack isEmpty ifFalse: [^ self handleDataFrom: anInteger + 1 to: anotherInteger].
	self endData.
	(self isSelfClosingTag: aString) ifFalse: [self smartPop: aString].
	tag := SoupTag named: aString parent: tagStack last previous: previous.
	aDictionary keysAndValuesDo: [
		:key :value |
		tag attributeAt: key put: value
	].
	previous := tag.
	self pushTag: tag.
	(self isSelfClosingTag: aString) ifTrue: [
		tag beSelfClosing.
		self popTag
	].
	(parameters quoteTags includes: aString) 
		ifTrue: [
			quoteStack addLast: aString.
			literal := true
		].
	^ tag
	

	! !

!SoupParser methodsFor: 'initializing' stamp: 'za 2/11/2009 04:23'!
initialize
	super initialize.
	interesting := '[&<]' asRegex.
	startTagOpen := '<[>a-zA-Z]' asRegex.
	charRef := '&#([0-9]+)[^0-9]' asRegex.
	entityRef := '&([a-zA-Z][-.a-zA-Z0-9]*)[^a-zA-Z0-9]' asRegex.
	endBracket := '[<>]' asRegex.
	tagFind := '[a-zA-Z][-_.a-zA-Z0-9]*' asRegex.
	attrFind := '\s*([a-zA-Z_][-:.a-zA-Z_0-9]*)(\s*=\s*(''[^'']*''|"[^"]*"|[\-a-zA-Z0-9./,:;+*%?!!&$()_#=~''"@]*))?' asRegex.
	incomplete := '&([a-zA-Z][a-zA-Z0-9]*|#[0-9]*)?|<([a-zA-Z][^<>]*|/([a-zA-Z][^<>]*)?|!![^<>]*)?' asRegex.
	refFind := '&(([a-zA-Z][-.a-zA-Z0-9]*)|#(\w+))(;)?' asRegex.	! !

!SoupParser methodsFor: 'handling' stamp: 'za 12/26/2008 22:37'!
isNestable: aString
	^ parameters nestableTags includesKey: aString
! !

!SoupParser methodsFor: 'handling' stamp: 'za 12/26/2008 22:35'!
isResetNesting: aString
	^ parameters resetNestingTags includesKey: aString! !

!SoupParser methodsFor: 'handling' stamp: 'za 12/20/2008 10:53'!
isSelfClosingTag: aString
	^ parameters selfClosingTags includes: aString! !

!SoupParser methodsFor: 'massaging' stamp: 'za 12/9/2008 15:17'!
massage
	string := self replace: '(<[^<>]*)/>' using: [:aMatcher | (aMatcher subexpression: 2) , '/>'].
	string := self replace: '<!!\s+([^<>]*)>' using: [:aMatcher | '<!!' , (aMatcher subexpression: 2) , '>'].
! !

!SoupParser methodsFor: 'handling' stamp: 'za 12/23/2008 05:42'!
numPops: aString
	(tagStack size to: 2 by: -1) do: [
		:i |
		((tagStack at: i) name = aString) 
			ifTrue: [^ tagStack size - i + 1]
	].
	^ 0! !

!SoupParser methodsFor: 'accessing' stamp: 'za 12/20/2008 11:08'!
parameters: anObject
	parameters := anObject! !

!SoupParser methodsFor: 'parsing' stamp: 'za 12/26/2008 22:33'!
parse
	| position end |
	position := 0.
	end := string size.
	[position < end] whileTrue: [
		position := self parseAny: position.
		position < 0 ifTrue: [^ self]
	]
! !

!SoupParser methodsFor: 'handling' stamp: 'za 12/23/2008 04:25'!
parseAny: anInteger
	| i j |
	i := anInteger.
	j := self findInterestingFrom: i.
	i < j ifTrue: [self handleDataFrom: i + 1 to: j].
	i := j.
	i >= string size ifTrue: [^ string size].
	^ ((string at: i + 1) = $<) 
		ifTrue: [self parsePossibleTag: i]
		ifFalse: [self parsePossibleRef: i]
! !

!SoupParser methodsFor: 'parsing' stamp: 'za 12/26/2008 22:08'!
parseCData: anInteger
	| end |
	end := (string findString: ']]>' startingAt: anInteger) - 1.
	self handleCData: (string copyFrom: anInteger + 10 to: end).
	^ end + 3
! !

!SoupParser methodsFor: 'parsing' stamp: 'PaulDeBruicker 2/19/2010 10:35'!
parseCharRef: anInteger
	self handleCharRef: (charRef subexpression: 2).
	^ ((charRef subEnd: 2) first) + 1
! !

!SoupParser methodsFor: 'parsing' stamp: 'PaulDeBruicker 2/19/2010 10:36'!
parseComment: anInteger
	| matcher |
	matcher := '--\s*>' asRegex.
	(matcher searchStream: (self readStreamFrom: anInteger))
		ifTrue: [
			self handleComment: (string 
				copyFrom: anInteger + 5 
				to: (matcher subBeginning: 1) first).
			^ (matcher subEnd: 1) first.
		].
	^ self parseIncomplete: anInteger
		
	
	
! !

!SoupParser methodsFor: 'parsing' stamp: 'PaulDeBruicker 2/19/2010 09:33'!
parseDeclaration: anInteger
	| matcher |
	matcher := '<!!\s*((''[^'']*''|"["]*"|\w+)(\s+(''[^'']*''|"["]*"|\w+)))*>' asRegex.
	(matcher matchesStreamPrefix: (self readStreamFrom: anInteger))
		ifTrue: [
			self handleDeclaration: (matcher subexpression: 2).
			^ (matcher subEnd: 1) first.
		].
	^ self parseIncomplete: anInteger
	
! !

!SoupParser methodsFor: 'parsing' stamp: 'PaulDeBruicker 2/19/2010 09:36'!
parseEndTag: anInteger
	| end tag |
	(endBracket searchStream: (self readStreamFrom: anInteger  + 2)) 
		ifFalse: [^ self parseIncomplete: anInteger].
	end := (endBracket subEnd: 1) first.
	tag := string copyFrom: anInteger + 3 to: end - 1. 
	self handleEndTagFrom: anInteger + 1 to: end tag: tag.
	literal := false.
	^ end
! !

!SoupParser methodsFor: 'parsing' stamp: 'PaulDeBruicker 2/19/2010 10:35'!
parseEntityRef: anInteger
	self handleEntityRef: (entityRef subexpression: 2).
	^ ((entityRef subEnd: 2) first )+ 1
! !

!SoupParser methodsFor: 'parsing' stamp: 'PaulDeBruicker 2/19/2010 10:36'!
parseIncomplete: anInteger
	| j |
	(incomplete matchesStreamPrefix: (self readStreamFrom: anInteger))
		ifFalse: [
			self handleDataFrom: anInteger to: anInteger.
			^ anInteger + 1
		].
	j := (incomplete subEnd: 1) first.
	j >= string size ifTrue: [^ -1].
	self handleDataFrom: anInteger + 1 to: j.
	^ j
	

	
	
! !

!SoupParser methodsFor: 'parsing' stamp: 'za 12/23/2008 03:52'!
parseLiteral: anInteger
	| i |
	i := anInteger + 1.
	self handleDataFrom: i to: i.
	^ i
	
	
! !

!SoupParser methodsFor: 'parsing' stamp: 'za 12/25/2008 06:12'!
parsePossibleDeclaration: anInteger
	^ (self equals: '<!![CDATA[' from: anInteger)
		ifTrue: [self parseCData: anInteger]
		ifFalse: [self parseDeclaration: anInteger]
	
	
! !

!SoupParser methodsFor: 'parsing' stamp: 'za 12/23/2008 03:37'!
parsePossibleLiteral: anInteger
	^ (string size > (anInteger + 1))
		ifTrue: [self parseLiteral: anInteger]
		ifFalse: [self parseIncomplete: anInteger]! !

!SoupParser methodsFor: 'parsing' stamp: 'za 12/23/2008 04:39'!
parsePossibleOtherTag: anInteger
	^ ((string at: anInteger+2) = $/) 
		ifTrue: [self parseEndTag: anInteger]
		ifFalse: [self parsePossibleSpecialTag: anInteger]
! !

!SoupParser methodsFor: 'parsing' stamp: 'za 12/26/2008 22:22'!
parsePossibleRef: anInteger
	literal ifTrue: [^ self parseLiteral: anInteger].
	(charRef matchesStreamPrefix: (self readStreamFrom: anInteger)) 
		ifTrue: [^ self parseCharRef: anInteger].
	(entityRef matchesStreamPrefix: (self readStreamFrom: anInteger)) 
		ifTrue: [^ self parseEntityRef: anInteger].
	^ self parseIncomplete: anInteger! !

!SoupParser methodsFor: 'parsing' stamp: 'za 12/26/2008 22:23'!
parsePossibleSpecialTag: anInteger
	literal ifTrue: [^ self parsePossibleLiteral: anInteger].
	(self equals: '<!!--' from: anInteger) 
		ifTrue: [^ self parseComment: anInteger].
	((string at: anInteger + 2) = $?)  
		ifTrue: [^ self parseProcessingInstruction: anInteger].
	((string at: anInteger + 2) = $!!)  
		ifTrue: [^ self parsePossibleDeclaration: anInteger].
	^ self parseIncomplete: anInteger
	
	
! !

!SoupParser methodsFor: 'parsing' stamp: 'za 12/23/2008 03:23'!
parsePossibleStartTag: anInteger
	literal ifTrue: [^ self parseLiteral: anInteger].
	^ self parseStartTag: anInteger
	
! !

!SoupParser methodsFor: 'parsing' stamp: 'za 12/23/2008 03:25'!
parsePossibleTag: anInteger
	^ (startTagOpen matchesStreamPrefix: (self readStreamFrom: anInteger))
		ifTrue: [self parsePossibleStartTag: anInteger]
		ifFalse: [self parsePossibleOtherTag: anInteger]
! !

!SoupParser methodsFor: 'parsing' stamp: 'za 12/26/2008 22:27'!
parseProcessingInstruction: anInteger
	| end |
	end := string findString: '>' startingAt: anInteger.
	(end > 0)
		ifTrue: [
			|  processingInstruction |
			processingInstruction := string 
				copyFrom: anInteger + 3 
				to: end - 1.
			self handleProcessingInstruction: processingInstruction.
			^ end
		].
	^ self parseIncomplete: anInteger
! !

!SoupParser methodsFor: 'parsing' stamp: 'PaulDeBruicker 2/19/2010 09:33'!
parseStartTag: anInteger
	| j k tag attrs |
	(endBracket searchStream: (self readStreamFrom: anInteger + 1))
		ifFalse: [^ self parseIncomplete: anInteger].
	attrs := Dictionary new.
	j := (endBracket subBeginning: 1) first.
	(tagFind matchesStreamPrefix: (self readStreamFrom: anInteger + 1))
		ifFalse: [self error: '#parseStartTagFrom: should not have been sent']
		ifTrue: [
			k := (tagFind subEnd: 1) first.
			tag := (tagFind subexpression: 1) asLowercase
		].
	[k < j] whileTrue: [
		k := self parseStartTagAttribute: k into: attrs.
		(k = -1) ifTrue: [k := j]
	].
	self handleStartTagFrom: anInteger to: j tag: tag attrs: attrs.
	(string at: j + 1) = $> ifTrue: [j := j + 1].
	^ j
! !

!SoupParser methodsFor: 'parsing' stamp: 'PaulDeBruicker 2/19/2010 09:35'!
parseStartTagAttribute: anInteger into: aDictionary
	| attrName rest attrValue |
	(attrFind matchesStreamPrefix: (self readStreamFrom: anInteger))
		ifFalse: [^ -1].
	attrName := attrFind subexpression: 2.
	rest := attrFind subexpression: 3.
	attrValue := attrFind subexpression: 4.
	rest 
		ifNil: [attrValue := attrName]
		ifNotNil: [
			attrValue ifNotEmpty: [
				((attrValue first = $' and: [attrValue last = $']) 
					or: [attrValue first = $" and: [attrValue last = $"]])
					ifTrue: [
						attrValue := attrValue 
							copyFrom: 2 
							to: (attrValue size - 1)
					].
				attrValue := self 
					copy: attrValue 
					replace: refFind
					using: [:aMatcher | self convertRef: aMatcher].
			]
		].
	aDictionary at: attrName put: attrValue.
	^ (attrFind subEnd: 1) first.
! !

!SoupParser methodsFor: 'parsing' stamp: 'za 12/30/2008 04:01'!
parseString: aString
	string := aString.
	self decode.
	self reset.
	self massage.
	self parse.
	self endData.
	[tagStack last isSoup] whileFalse: [self popTag].
	^ tagStack last! !

!SoupParser methodsFor: 'handling' stamp: 'za 12/26/2008 22:55'!
popTag
	tagStack removeLast.


! !

!SoupParser methodsFor: 'handling' stamp: 'za 12/26/2008 22:51'!
popToTag: aString 
	self popToTag: aString inclusive: true! !

!SoupParser methodsFor: 'handling' stamp: 'za 12/26/2008 22:52'!
popToTag: aString inclusive: aBoolean
	| numPops |
	(aString = Soup defaultName) ifTrue: [^ self].
	numPops := self numPops: aString.
	aBoolean ifFalse: [numPops := numPops - 1].
	numPops timesRepeat: [self popTag].
! !

!SoupParser methodsFor: 'handling' stamp: 'za 12/26/2008 22:55'!
pushTag: aTag
	tagStack addLast: aTag.

! !

!SoupParser methodsFor: 'parsing' stamp: 'za 12/23/2008 03:05'!
readStreamFrom: anInteger
	^ string readStream position: anInteger
! !

!SoupParser methodsFor: 'massaging' stamp: 'za 12/9/2008 15:17'!
replace: regexString using: aBlock
	^ self copy: string replace: regexString using: aBlock
! !

!SoupParser methodsFor: 'initializing' stamp: 'za 12/26/2008 22:55'!
reset
	currentData := ReadWriteStream on: String new.
	tagStack := OrderedCollection new.
	quoteStack := OrderedCollection new.
	literal := false.
	self pushTag: self createRootTag! !

!SoupParser methodsFor: 'handling' stamp: 'za 12/26/2008 22:53'!
smartPop: aString
	tagStack reverseDo: [
		:aTag |
		| nestingResetTriggers |
		((aTag isNil or: [aString = aTag name]) and: [(self isNestable: aString) not])
			ifTrue: [^ self popToTag: aString inclusive: true].
		nestingResetTriggers := parameters nestableTags at: aString ifAbsent: [#()].
		((nestingResetTriggers includes: aTag name) 
			or: [nestingResetTriggers isEmpty 
				and: [(self isResetNesting: aString) 
					and: [self isResetNesting: aTag name]]])
			ifTrue: [^ self popToTag: aTag name inclusive: false]
	]! !

!SoupParser methodsFor: 'accessing' stamp: 'za 12/9/2008 16:11'!
string: anObject
	string := anObject! !

Object subclass: #SoupParserParameters
	instanceVariableNames: 'selfClosingTags nestableInlineTags nestableBlockTags nestableListTags nestableTableTags nestableTags nonNestableBlockTags resetNestingTags quoteTags entityDefinitions'
	classVariableNames: 'ForHtml'
	poolDictionaries: ''
	category: 'Soup-Parser'!

!SoupParserParameters class methodsFor: 'defaults' stamp: 'za 12/20/2008 10:47'!
forHtml
	^ ForHtml ifNil: [
		ForHtml := self basicNew 
			initializeForHtml; 
			yourself
		]! !

!SoupParserParameters class methodsFor: 'defaults' stamp: 'za 12/23/2008 02:51'!
reset
	ForHtml := nil! !

!SoupParserParameters methodsFor: 'accessing' stamp: 'za 12/26/2008 23:12'!
entityDefinitions
	^ entityDefinitions! !

!SoupParserParameters methodsFor: 'accessing' stamp: 'za 12/25/2008 01:22'!
entityDefs
	^ entityDefs! !

!SoupParserParameters methodsFor: 'initializing (html)' stamp: 'za 12/26/2008 23:12'!
initializeEntityDefinitionsForHtml
	entityDefinitions := Dictionary newFrom: {
		'lt' -> '<'.
		'gt' -> '>'.
		'amp' -> '&'.	
		'quot' -> ''''.
		'apos' -> ''''.
	}
! !

!SoupParserParameters methodsFor: 'initializing (html)' stamp: 'za 12/26/2008 23:10'!
initializeForHtml
	self initializeEntityDefinitionsForHtml.
	self initializeSelfClosingTagsForHtml.
	self initializeNestableInlineTagsForHtml.
	self initializeNestableBlockTagsForHtml.
	self initializeNestableListTagsForHtml.
	self initializeNestableTableTagsForHtml.
	self initializeNestableTagsForHtml.
	self initializeNonNestableBlockTagsForHtml.
	self initializeResetNestingTagsForHtml.
	self initializeQuoteTagsForHtml.
! !

!SoupParserParameters methodsFor: 'initializing (html)' stamp: 'za 12/26/2008 23:03'!
initializeNestableBlockTagsForHtml
	nestableBlockTags := Dictionary newFrom: {
		#blockquote -> #().
		#div -> #().
		#fieldset -> #().
		#ins -> #().
		#del -> #()
	}.
! !

!SoupParserParameters methodsFor: 'initializing (html)' stamp: 'za 12/26/2008 23:02'!
initializeNestableInlineTagsForHtml
	nestableInlineTags := Dictionary newFrom: {
		#span -> #().
		#font -> #().
		#q -> #().
		#object -> #().
		#bdo -> #().
		#sub -> #().
		#sup -> #().
		#center -> #()
	}.
! !

!SoupParserParameters methodsFor: 'initializing (html)' stamp: 'za 12/26/2008 23:04'!
initializeNestableListTagsForHtml
	nestableListTags := Dictionary newFrom: {
		#ol -> #().
		#ul -> #().
		#li -> #(ol ul).
		#dl -> #().
		#dd -> #(dl).
		#dt -> #(dl)
	}.
! !

!SoupParserParameters methodsFor: 'initializing (html)' stamp: 'za 12/26/2008 23:05'!
initializeNestableTableTagsForHtml
	nestableTableTags := Dictionary newFrom: {
		#table -> #().
		#tr -> #(table tbody tfoot thead).
		#td -> #(tr).
		#th -> #(td).
		#thead -> #(table).
		#tbody -> #(table).
		#tfoot -> #(table).
	}.
! !

!SoupParserParameters methodsFor: 'initializing (html)' stamp: 'za 12/26/2008 23:06'!
initializeNestableTagsForHtml
	nestableTags := Dictionary new.
	nestableTags
		addAll: nestableInlineTags;
		addAll: nestableBlockTags;
		addAll: nestableListTags;
		addAll: nestableTableTags.
! !

!SoupParserParameters methodsFor: 'initializing (html)' stamp: 'za 12/26/2008 23:07'!
initializeNonNestableBlockTagsForHtml
	nonNestableBlockTags := Dictionary newFrom: {
		#address -> #().
		#form -> #().
		#p -> #().
		#pre -> #().
	}.
! !

!SoupParserParameters methodsFor: 'initializing (html)' stamp: 'za 12/26/2008 23:10'!
initializeQuoteTagsForHtml
	quoteTags := #(script  textarea)
! !

!SoupParserParameters methodsFor: 'initializing (html)' stamp: 'za 12/26/2008 23:08'!
initializeResetNestingTagsForHtml
	resetNestingTags := Dictionary new.
	resetNestingTags 
		addAll: nestableBlockTags;
		addAll: nonNestableBlockTags;
		addAll: nestableListTags;
		addAll: nestableTags;
		at: #noscript put: #().
! !

!SoupParserParameters methodsFor: 'initializing (html)' stamp: 'za 12/26/2008 23:01'!
initializeSelfClosingTagsForHtml
	selfClosingTags := #(br hr input img meta spacer link frame base).
! !

!SoupParserParameters methodsFor: 'accessing' stamp: 'za 12/20/2008 11:10'!
nestableTags
	^ nestableTags! !

!SoupParserParameters methodsFor: 'accessing' stamp: 'za 12/20/2008 11:09'!
quoteTags
	^ quoteTags! !

!SoupParserParameters methodsFor: 'accessing' stamp: 'za 12/20/2008 11:10'!
resetNestingTags
	^ resetNestingTags ! !

!SoupParserParameters methodsFor: 'accessing' stamp: 'za 12/20/2008 11:08'!
selfClosingTags
	^ selfClosingTags! !

!RxMatcher methodsFor: '*Soup-testing' stamp: 'za 2/15/2009 18:51'!
isMatcher
	^ true! !

TextConverter subclass: #ASCIITextConverter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Soup-TextConversion'!

!ASCIITextConverter class methodsFor: 'as yet unclassified' stamp: 'za 12/30/2008 04:18'!
encodingNames 
	^ #('ascii') copy
! !

!ASCIITextConverter methodsFor: 'friend' stamp: 'za 12/30/2008 04:17'!
currentCharSize

	^ 1.
! !

!ASCIITextConverter methodsFor: 'conversion' stamp: 'za 12/30/2008 04:17'!
nextFromStream: aStream
	| character |
	character := aStream basicNext.
	character charCode > 127 
		ifTrue: [self error: 'Invalid ASCII character ' , character asString].
	^ character
! !

!ASCIITextConverter methodsFor: 'conversion' stamp: 'za 12/30/2008 04:17'!
nextPut: aCharacter toStream: aStream 
	aCharacter charCode > 127 
		ifTrue: [self error: 'Invalid ASCII character ' , aCharacter asString].
	aStream basicNextPut: (Character value: aCharacter charCode).
! !

TextConverter subclass: #CP1252TextConverter
	instanceVariableNames: ''
	classVariableNames: 'FromTable ToTable'
	poolDictionaries: ''
	category: 'Soup-TextConversion'!

!CP1252TextConverter class methodsFor: 'as yet unclassified' stamp: 'za 12/30/2008 02:34'!
encodingNames 
	^ #('windows-1252' 'cp-1252') copy
! !

!CP1252TextConverter class methodsFor: 'as yet unclassified' stamp: 'za 12/30/2008 03:01'!
initialize
	ToTable := Dictionary new.
	ToTable at: 16r80 put: 16r20AC.
	"16r81 is unused "
	ToTable at: 16r82 put: 16r201A.
	ToTable at: 16r83 put: 16r0192.
	ToTable at: 16r84 put: 16r201E.
	ToTable at: 16r85 put: 16r2026.
	ToTable at: 16r86 put: 16r2020.
	ToTable at: 16r87 put: 16r2021.
	ToTable at: 16r88 put: 16r02C6.
	ToTable at: 16r89 put: 16r2030.
	ToTable at: 16r8A put: 16r0160.
	ToTable at: 16r8B put: 16r2039.
	ToTable at: 16r8C put: 16r0152.
	"16r8D is unused "
	ToTable at: 16r8E put: 16r017D.
	"16r8F is unused "
	"16r90 is unused "
	ToTable at: 16r91 put: 16r2018.
	ToTable at: 16r92 put: 16r2019.
	ToTable at: 16r93 put: 16r201C.
	ToTable at: 16r94 put: 16r201D.
	ToTable at: 16r95 put: 16r2022.
	ToTable at: 16r96 put: 16r2013.
	ToTable at: 16r97 put: 16r2014.
	ToTable at: 16r98 put: 16r02DC.
	ToTable at: 16r99 put: 16r2122.
	ToTable at: 16r9A put: 16r0161.
	ToTable at: 16r9B put: 16r203A.
	ToTable at: 16r9C put: 16r0153.
	"16r9D is unused "
	ToTable at: 16r9E put: 16r017E.
	ToTable at: 16r9F put: 16r0178.

	FromTable := Dictionary new.
	ToTable keysAndValuesDo: [
		:key :value |
		FromTable at: value put: key
	]! !

!CP1252TextConverter methodsFor: 'as yet unclassified' stamp: 'za 12/30/2008 02:40'!
fromSqueak: aCharacter
	^ FromTable at: aCharacter charCode ifAbsent: [aCharacter asciiValue]! !

!CP1252TextConverter methodsFor: 'as yet unclassified' stamp: 'za 12/30/2008 02:41'!
nextFromStream: aStream
	| character |
	aStream isBinary ifTrue: [^ aStream basicNext].
	character := aStream basicNext.
	character ifNil: [^ nil].
	^ self toSqueak: character.
! !

!CP1252TextConverter methodsFor: 'as yet unclassified' stamp: 'za 12/30/2008 02:42'!
nextPut: aCharacter toStream: aStream
	aStream isBinary ifTrue: [^ aCharacter storeBinaryOn: aStream].
	aCharacter charCode < 128 
		ifTrue: [aStream basicNextPut: aCharacter] 
		ifFalse: [aStream basicNextPut: ((Character value: (self fromSqueak: aCharacter) charCode))].
! !

!CP1252TextConverter methodsFor: 'as yet unclassified' stamp: 'za 12/30/2008 03:23'!
toSqueak: aCharacter
	| value |
	value := aCharacter charCode.
	(value >= 128 and: [value <= 159])
		ifTrue: [^ ToTable at: aCharacter charCode].
	^ aCharacter! !
CP1252TextConverter initialize!
